/* delayed-load.c generated by valac 0.40.7, the Vala compiler
 * generated from delayed-load.vala, do not modify */

/*
   Copyright (C) 2012-2013 André Stösel <andre@stoesel.de>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   See the file COPYING for the full license text.
*/


#include <glib.h>
#include <glib-object.h>
#include "midori/midori-extension.h"
#include "midori/midori-view.h"
#include "katze/katze.h"
#include "midori-core.h"
#include "midori/midori-browser.h"
#include "midori/midori-app.h"
#include <glib/gi18n-lib.h>
#include "delayed-load.h"


#define DELAYED_LOAD_TYPE_MANAGER (delayed_load_manager_get_type ())
#define DELAYED_LOAD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DELAYED_LOAD_TYPE_MANAGER, DelayedLoadManager))
#define DELAYED_LOAD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DELAYED_LOAD_TYPE_MANAGER, DelayedLoadManagerClass))
#define DELAYED_LOAD_IS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DELAYED_LOAD_TYPE_MANAGER))
#define DELAYED_LOAD_IS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DELAYED_LOAD_TYPE_MANAGER))
#define DELAYED_LOAD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DELAYED_LOAD_TYPE_MANAGER, DelayedLoadManagerClass))

typedef struct _DelayedLoadManager DelayedLoadManager;
typedef struct _DelayedLoadManagerClass DelayedLoadManagerClass;
typedef struct _DelayedLoadManagerPrivate DelayedLoadManagerPrivate;
enum  {
	DELAYED_LOAD_MANAGER_0_PROPERTY,
	DELAYED_LOAD_MANAGER_NUM_PROPERTIES
};
static GParamSpec* delayed_load_manager_properties[DELAYED_LOAD_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DelayedLoadManager {
	MidoriExtension parent_instance;
	DelayedLoadManagerPrivate * priv;
};

struct _DelayedLoadManagerClass {
	MidoriExtensionClass parent_class;
};


static gpointer delayed_load_manager_parent_class = NULL;

GType delayed_load_manager_get_type (void) G_GNUC_CONST;
static void delayed_load_manager_tab_changed (DelayedLoadManager* self,
                                       MidoriView* old_view,
                                       MidoriView* new_view);
static void delayed_load_manager_browser_added (DelayedLoadManager* self,
                                         MidoriBrowser* browser);
static void _delayed_load_manager_tab_changed_midori_browser_switch_tab (MidoriBrowser* _sender,
                                                                  MidoriView* old_view,
                                                                  MidoriView* new_view,
                                                                  gpointer self);
static void delayed_load_manager_browser_removed (DelayedLoadManager* self,
                                           MidoriBrowser* browser);
void delayed_load_manager_activated (DelayedLoadManager* self,
                                     MidoriApp* app);
static void _delayed_load_manager_browser_added_midori_app_add_browser (MidoriApp* _sender,
                                                                 MidoriBrowser* browser,
                                                                 gpointer self);
void delayed_load_manager_deactivated (DelayedLoadManager* self);
DelayedLoadManager* delayed_load_manager_new (void);
DelayedLoadManager* delayed_load_manager_construct (GType object_type);
static void _delayed_load_manager_activated_midori_extension_activate (MidoriExtension* _sender,
                                                                MidoriApp* app,
                                                                gpointer self);
static void _delayed_load_manager_deactivated_midori_extension_deactivate (MidoriExtension* _sender,
                                                                    gpointer self);


static void
delayed_load_manager_tab_changed (DelayedLoadManager* self,
                                  MidoriView* old_view,
                                  MidoriView* new_view)
{
#line 14 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_return_if_fail (self != NULL);
#line 15 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	if (new_view != NULL) {
#line 94 "delayed-load.c"
		KatzeItem* item = NULL;
		KatzeItem* _tmp0_;
		gint64 delay = 0LL;
		KatzeItem* _tmp1_;
		gboolean _tmp2_ = FALSE;
		gint64 _tmp3_;
#line 16 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		_tmp0_ = midori_view_get_proxy_item (new_view);
#line 16 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		item = _tmp0_;
#line 18 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		_tmp1_ = item;
#line 18 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		delay = katze_item_get_meta_integer (_tmp1_, "delay");
#line 19 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		_tmp3_ = delay;
#line 19 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		if (_tmp3_ == ((gint64) MIDORI_DELAY_PENDING_UNDELAY)) {
#line 113 "delayed-load.c"
			gdouble _tmp4_;
			gdouble _tmp5_;
#line 19 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
			_tmp4_ = midori_tab_get_progress ((MidoriTab*) new_view);
#line 19 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
			_tmp5_ = _tmp4_;
#line 19 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
			_tmp2_ = _tmp5_ < 1.0;
#line 122 "delayed-load.c"
		} else {
#line 19 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
			_tmp2_ = FALSE;
#line 126 "delayed-load.c"
		}
#line 19 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		if (_tmp2_) {
#line 20 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
			midori_view_reload (new_view, TRUE);
#line 132 "delayed-load.c"
		}
	}
}


static void
_delayed_load_manager_tab_changed_midori_browser_switch_tab (MidoriBrowser* _sender,
                                                             MidoriView* old_view,
                                                             MidoriView* new_view,
                                                             gpointer self)
{
#line 26 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	delayed_load_manager_tab_changed ((DelayedLoadManager*) self, old_view, new_view);
#line 146 "delayed-load.c"
}


static void
delayed_load_manager_browser_added (DelayedLoadManager* self,
                                    MidoriBrowser* browser)
{
#line 25 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_return_if_fail (self != NULL);
#line 25 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_return_if_fail (browser != NULL);
#line 26 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_signal_connect_object (browser, "switch-tab", (GCallback) _delayed_load_manager_tab_changed_midori_browser_switch_tab, self, G_CONNECT_AFTER);
#line 160 "delayed-load.c"
}


static void
delayed_load_manager_browser_removed (DelayedLoadManager* self,
                                      MidoriBrowser* browser)
{
	guint _tmp0_;
#line 29 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_return_if_fail (self != NULL);
#line 29 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_return_if_fail (browser != NULL);
#line 30 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_signal_parse_name ("switch-tab", MIDORI_TYPE_BROWSER, &_tmp0_, NULL, FALSE);
#line 30 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_signal_handlers_disconnect_matched (browser, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _delayed_load_manager_tab_changed_midori_browser_switch_tab, self);
#line 177 "delayed-load.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	return self ? g_object_ref (self) : NULL;
#line 186 "delayed-load.c"
}


static void
_delayed_load_manager_browser_added_midori_app_add_browser (MidoriApp* _sender,
                                                            MidoriBrowser* browser,
                                                            gpointer self)
{
#line 37 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	delayed_load_manager_browser_added ((DelayedLoadManager*) self, browser);
#line 197 "delayed-load.c"
}


void
delayed_load_manager_activated (DelayedLoadManager* self,
                                MidoriApp* app)
{
	GList* _tmp0_;
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_return_if_fail (app != NULL);
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	_tmp0_ = midori_app_get_browsers (app);
#line 212 "delayed-load.c"
	{
		GList* browser_collection = NULL;
		GList* browser_it = NULL;
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		browser_collection = _tmp0_;
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		for (browser_it = browser_collection; browser_it != NULL; browser_it = browser_it->next) {
#line 220 "delayed-load.c"
			MidoriBrowser* _tmp1_;
			MidoriBrowser* browser = NULL;
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
			_tmp1_ = _g_object_ref0 ((MidoriBrowser*) browser_it->data);
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
			browser = _tmp1_;
#line 227 "delayed-load.c"
			{
				MidoriBrowser* _tmp2_;
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
				_tmp2_ = browser;
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
				delayed_load_manager_browser_added (self, _tmp2_);
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
				_g_object_unref0 (browser);
#line 236 "delayed-load.c"
			}
		}
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		(browser_collection == NULL) ? NULL : (browser_collection = (g_list_free (browser_collection), NULL));
#line 241 "delayed-load.c"
	}
#line 37 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_signal_connect_object (app, "add-browser", (GCallback) _delayed_load_manager_browser_added_midori_app_add_browser, self, 0);
#line 245 "delayed-load.c"
}


void
delayed_load_manager_deactivated (DelayedLoadManager* self)
{
	MidoriApp* app = NULL;
	MidoriApp* _tmp0_;
	MidoriApp* _tmp1_;
	MidoriApp* _tmp2_;
	GList* _tmp3_;
	MidoriApp* _tmp6_;
	guint _tmp7_;
#line 40 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_return_if_fail (self != NULL);
#line 41 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	_tmp0_ = midori_extension_get_app ((MidoriExtension*) self);
#line 41 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 41 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	app = _tmp1_;
#line 42 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	_tmp2_ = app;
#line 42 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	_tmp3_ = midori_app_get_browsers (_tmp2_);
#line 271 "delayed-load.c"
	{
		GList* browser_collection = NULL;
		GList* browser_it = NULL;
#line 42 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		browser_collection = _tmp3_;
#line 42 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		for (browser_it = browser_collection; browser_it != NULL; browser_it = browser_it->next) {
#line 279 "delayed-load.c"
			MidoriBrowser* _tmp4_;
			MidoriBrowser* browser = NULL;
#line 42 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
			_tmp4_ = _g_object_ref0 ((MidoriBrowser*) browser_it->data);
#line 42 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
			browser = _tmp4_;
#line 286 "delayed-load.c"
			{
				MidoriBrowser* _tmp5_;
#line 43 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
				_tmp5_ = browser;
#line 43 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
				delayed_load_manager_browser_removed (self, _tmp5_);
#line 42 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
				_g_object_unref0 (browser);
#line 295 "delayed-load.c"
			}
		}
#line 42 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
		(browser_collection == NULL) ? NULL : (browser_collection = (g_list_free (browser_collection), NULL));
#line 300 "delayed-load.c"
	}
#line 45 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	_tmp6_ = app;
#line 45 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_signal_parse_name ("add-browser", MIDORI_TYPE_APP, &_tmp7_, NULL, FALSE);
#line 45 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _delayed_load_manager_browser_added_midori_app_add_browser, self);
#line 40 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	_g_object_unref0 (app);
#line 310 "delayed-load.c"
}


static void
_delayed_load_manager_activated_midori_extension_activate (MidoriExtension* _sender,
                                                           MidoriApp* app,
                                                           gpointer self)
{
#line 54 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	delayed_load_manager_activated ((DelayedLoadManager*) self, app);
#line 321 "delayed-load.c"
}


static void
_delayed_load_manager_deactivated_midori_extension_deactivate (MidoriExtension* _sender,
                                                               gpointer self)
{
#line 55 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	delayed_load_manager_deactivated ((DelayedLoadManager*) self);
#line 331 "delayed-load.c"
}


DelayedLoadManager*
delayed_load_manager_construct (GType object_type)
{
	DelayedLoadManager * self = NULL;
#line 49 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	self = (DelayedLoadManager*) g_object_new (object_type, "name", _ ("Delayed load"), "description", _ ("Delay page load until you actually use the tab."), "version", "0.2", "authors", "André Stösel <andre@stoesel.de>", NULL);
#line 54 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_signal_connect_object ((MidoriExtension*) self, "activate", (GCallback) _delayed_load_manager_activated_midori_extension_activate, self, 0);
#line 55 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	g_signal_connect_object ((MidoriExtension*) self, "deactivate", (GCallback) _delayed_load_manager_deactivated_midori_extension_deactivate, self, 0);
#line 48 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	return self;
#line 347 "delayed-load.c"
}


DelayedLoadManager*
delayed_load_manager_new (void)
{
#line 48 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	return delayed_load_manager_construct (DELAYED_LOAD_TYPE_MANAGER);
#line 356 "delayed-load.c"
}


static void
delayed_load_manager_class_init (DelayedLoadManagerClass * klass)
{
#line 13 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	delayed_load_manager_parent_class = g_type_class_peek_parent (klass);
#line 365 "delayed-load.c"
}


static void
delayed_load_manager_instance_init (DelayedLoadManager * self)
{
}


GType
delayed_load_manager_get_type (void)
{
	static volatile gsize delayed_load_manager_type_id__volatile = 0;
	if (g_once_init_enter (&delayed_load_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DelayedLoadManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) delayed_load_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DelayedLoadManager), 0, (GInstanceInitFunc) delayed_load_manager_instance_init, NULL };
		GType delayed_load_manager_type_id;
		delayed_load_manager_type_id = g_type_register_static (MIDORI_TYPE_EXTENSION, "DelayedLoadManager", &g_define_type_info, 0);
		g_once_init_leave (&delayed_load_manager_type_id__volatile, delayed_load_manager_type_id);
	}
	return delayed_load_manager_type_id__volatile;
}


MidoriExtension*
extension_init (void)
{
	MidoriExtension* result = NULL;
	DelayedLoadManager* _tmp0_;
#line 61 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	_tmp0_ = delayed_load_manager_new ();
#line 61 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	result = (MidoriExtension*) _tmp0_;
#line 61 "/builddir/build/BUILD/midori-0.5.12/extensions/delayed-load.vala"
	return result;
#line 400 "delayed-load.c"
}



