/* midori-bookmarksdatabase.c generated by valac 0.40.7, the Vala compiler
 * generated from midori-bookmarksdatabase.vala, do not modify */

/*
 Copyright (C) 2013 Andre Auzi <aauzi@free.fr>
 Copyright (C) 2013 Christian Dywan <christian@twotoats.de>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <unistd.h>


#define MIDORI_TYPE_DATABASE (midori_database_get_type ())
#define MIDORI_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDORI_TYPE_DATABASE, MidoriDatabase))
#define MIDORI_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MIDORI_TYPE_DATABASE, MidoriDatabaseClass))
#define MIDORI_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDORI_TYPE_DATABASE))
#define MIDORI_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDORI_TYPE_DATABASE))
#define MIDORI_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDORI_TYPE_DATABASE, MidoriDatabaseClass))

typedef struct _MidoriDatabase MidoriDatabase;
typedef struct _MidoriDatabaseClass MidoriDatabaseClass;
typedef struct _MidoriDatabasePrivate MidoriDatabasePrivate;

#define MIDORI_TYPE_BOOKMARKS_DATABASE (midori_bookmarks_database_get_type ())
#define MIDORI_BOOKMARKS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDORI_TYPE_BOOKMARKS_DATABASE, MidoriBookmarksDatabase))
#define MIDORI_BOOKMARKS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MIDORI_TYPE_BOOKMARKS_DATABASE, MidoriBookmarksDatabaseClass))
#define MIDORI_IS_BOOKMARKS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDORI_TYPE_BOOKMARKS_DATABASE))
#define MIDORI_IS_BOOKMARKS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDORI_TYPE_BOOKMARKS_DATABASE))
#define MIDORI_BOOKMARKS_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDORI_TYPE_BOOKMARKS_DATABASE, MidoriBookmarksDatabaseClass))

typedef struct _MidoriBookmarksDatabase MidoriBookmarksDatabase;
typedef struct _MidoriBookmarksDatabaseClass MidoriBookmarksDatabaseClass;
typedef struct _MidoriBookmarksDatabasePrivate MidoriBookmarksDatabasePrivate;
enum  {
	MIDORI_BOOKMARKS_DATABASE_0_PROPERTY,
	MIDORI_BOOKMARKS_DATABASE_NUM_PROPERTIES
};
static GParamSpec* midori_bookmarks_database_properties[MIDORI_BOOKMARKS_DATABASE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	MIDORI_DATABASE_ERROR_OPEN,
	MIDORI_DATABASE_ERROR_NAMING,
	MIDORI_DATABASE_ERROR_FILENAME,
	MIDORI_DATABASE_ERROR_EXECUTE,
	MIDORI_DATABASE_ERROR_COMPILE,
	MIDORI_DATABASE_ERROR_TYPE
} MidoriDatabaseError;
#define MIDORI_DATABASE_ERROR midori_database_error_quark ()
struct _MidoriDatabase {
	GObject parent_instance;
	MidoriDatabasePrivate * priv;
	gboolean trace;
	sqlite3* _db;
};

struct _MidoriDatabaseClass {
	GObjectClass parent_class;
	gboolean (*init) (MidoriDatabase* self, GCancellable* cancellable, GError** error);
};

struct _MidoriBookmarksDatabase {
	MidoriDatabase parent_instance;
	MidoriBookmarksDatabasePrivate * priv;
};

struct _MidoriBookmarksDatabaseClass {
	MidoriDatabaseClass parent_class;
};


static gpointer midori_bookmarks_database_parent_class = NULL;

GType midori_database_get_type (void) G_GNUC_CONST;
GQuark midori_database_error_quark (void);
GType midori_bookmarks_database_get_type (void) G_GNUC_CONST;
MidoriBookmarksDatabase* midori_bookmarks_database_new (GError** error);
MidoriBookmarksDatabase* midori_bookmarks_database_construct (GType object_type,
                                                              GError** error);
void midori_bookmarks_database_preinit (MidoriBookmarksDatabase* self,
                                        GError** error);
gboolean midori_database_init (MidoriDatabase* self,
                               GCancellable* cancellable,
                               GError** error);
gboolean midori_database_exec (MidoriDatabase* self,
                               const gchar* query,
                               GError** error);
gchar* midori_paths_get_config_filename_for_writing (const gchar* filename);
const gchar* midori_database_get_path (MidoriDatabase* self);
gchar* midori_paths_get_config_filename_for_reading (const gchar* filename);
sqlite3* midori_database_get_db (MidoriDatabase* self);
gboolean midori_database_exec_script (MidoriDatabase* self,
                                      const gchar* filename,
                                      GError** error);
gboolean midori_database_attach (MidoriDatabase* self,
                                 const gchar* path,
                                 const gchar* alias,
                                 GError** error);


MidoriBookmarksDatabase*
midori_bookmarks_database_construct (GType object_type,
                                     GError** error)
{
	MidoriBookmarksDatabase * self = NULL;
	GError * _inner_error_ = NULL;
#line 16 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	self = (MidoriBookmarksDatabase*) g_object_new (object_type, "path", "bookmarks.db", NULL);
#line 17 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	midori_bookmarks_database_preinit (self, &_inner_error_);
#line 17 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 17 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 17 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_propagate_error (error, _inner_error_);
#line 17 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_g_object_unref0 (self);
#line 17 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			return NULL;
#line 140 "midori-bookmarksdatabase.c"
		} else {
#line 17 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 17 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_clear_error (&_inner_error_);
#line 17 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			return NULL;
#line 148 "midori-bookmarksdatabase.c"
		}
	}
#line 18 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	midori_database_init ((MidoriDatabase*) self, NULL, &_inner_error_);
#line 18 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 18 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_propagate_error (error, _inner_error_);
#line 18 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_g_object_unref0 (self);
#line 18 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			return NULL;
#line 163 "midori-bookmarksdatabase.c"
		} else {
#line 18 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 18 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_clear_error (&_inner_error_);
#line 18 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			return NULL;
#line 171 "midori-bookmarksdatabase.c"
		}
	}
#line 19 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	midori_database_exec ((MidoriDatabase*) self, "PRAGMA foreign_keys = ON;", &_inner_error_);
#line 19 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 19 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 19 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_propagate_error (error, _inner_error_);
#line 19 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_g_object_unref0 (self);
#line 19 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			return NULL;
#line 186 "midori-bookmarksdatabase.c"
		} else {
#line 19 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 19 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_clear_error (&_inner_error_);
#line 19 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			return NULL;
#line 194 "midori-bookmarksdatabase.c"
		}
	}
#line 15 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	return self;
#line 199 "midori-bookmarksdatabase.c"
}


MidoriBookmarksDatabase*
midori_bookmarks_database_new (GError** error)
{
#line 15 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	return midori_bookmarks_database_construct (MIDORI_TYPE_BOOKMARKS_DATABASE, error);
#line 208 "midori-bookmarksdatabase.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 85 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	return self ? g_error_copy (self) : NULL;
#line 217 "midori-bookmarksdatabase.c"
}


void
midori_bookmarks_database_preinit (MidoriBookmarksDatabase* self,
                                   GError** error)
{
	gchar* dbfile = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* olddbfile = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* dbfile_v2 = NULL;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	GError * _inner_error_ = NULL;
#line 22 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	g_return_if_fail (self != NULL);
#line 23 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_tmp0_ = midori_database_get_path ((MidoriDatabase*) self);
#line 23 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_tmp1_ = _tmp0_;
#line 23 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_tmp2_ = midori_paths_get_config_filename_for_writing (_tmp1_);
#line 23 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	dbfile = _tmp2_;
#line 24 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_tmp3_ = dbfile;
#line 24 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_tmp4_ = g_strconcat (_tmp3_, ".old", NULL);
#line 24 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	olddbfile = _tmp4_;
#line 25 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_tmp5_ = midori_paths_get_config_filename_for_reading ("bookmarks_v2.db");
#line 25 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	dbfile_v2 = _tmp5_;
#line 27 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_tmp6_ = dbfile_v2;
#line 27 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	if (g_file_test (_tmp6_, G_FILE_TEST_EXISTS)) {
#line 260 "midori-bookmarksdatabase.c"
		const gchar* _tmp7_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		sqlite3* _tmp15_ = NULL;
		gint _tmp16_;
		sqlite3_stmt* stmt = NULL;
		sqlite3* _tmp23_;
		sqlite3* _tmp24_;
		sqlite3_stmt* _tmp25_ = NULL;
		gint _tmp26_;
		sqlite3_stmt* _tmp34_;
		gint64 user_version = 0LL;
		sqlite3_stmt* _tmp42_;
		gint64 _tmp43_;
#line 28 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp7_ = dbfile;
#line 28 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		if (g_file_test (_tmp7_, G_FILE_TEST_EXISTS)) {
#line 280 "midori-bookmarksdatabase.c"
			const gchar* _tmp8_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 29 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp8_ = olddbfile;
#line 29 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			if (g_file_test (_tmp8_, G_FILE_TEST_EXISTS)) {
#line 288 "midori-bookmarksdatabase.c"
				const gchar* _tmp9_;
#line 30 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp9_ = olddbfile;
#line 30 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				unlink (_tmp9_);
#line 294 "midori-bookmarksdatabase.c"
			}
#line 31 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp10_ = dbfile;
#line 31 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp11_ = olddbfile;
#line 31 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			g_rename (_tmp10_, _tmp11_);
#line 302 "midori-bookmarksdatabase.c"
		}
#line 34 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp12_ = dbfile_v2;
#line 34 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp13_ = dbfile;
#line 34 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		g_rename (_tmp12_, _tmp13_);
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp14_ = dbfile;
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp16_ = sqlite3_open_v2 (_tmp14_, &_tmp15_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_sqlite3_close0 (((MidoriDatabase*) self)->_db);
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		((MidoriDatabase*) self)->_db = _tmp15_;
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		if (_tmp16_ != SQLITE_OK) {
#line 320 "midori-bookmarksdatabase.c"
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			GError* _tmp21_;
			GError* _tmp22_;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp17_ = midori_database_get_path ((MidoriDatabase*) self);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp18_ = _tmp17_;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp19_ = g_strdup_printf ("Failed to open database %s", _tmp18_);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp20_ = _tmp19_;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp21_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_OPEN, _tmp20_);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp22_ = _tmp21_;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_g_free0 (_tmp20_);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_inner_error_ = _tmp22_;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_propagate_error (error, _inner_error_);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile_v2);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (olddbfile);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				return;
#line 355 "midori-bookmarksdatabase.c"
			} else {
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile_v2);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (olddbfile);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_clear_error (&_inner_error_);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				return;
#line 369 "midori-bookmarksdatabase.c"
			}
		}
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp23_ = midori_database_get_db ((MidoriDatabase*) self);
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp24_ = _tmp23_;
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp26_ = sqlite3_prepare_v2 (_tmp24_, "PRAGMA user_version;", -1, &_tmp25_, NULL);
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_sqlite3_finalize0 (stmt);
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		stmt = _tmp25_;
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		if (_tmp26_ != SQLITE_OK) {
#line 384 "midori-bookmarksdatabase.c"
			sqlite3* _tmp27_;
			sqlite3* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			GError* _tmp32_;
			GError* _tmp33_;
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp27_ = midori_database_get_db ((MidoriDatabase*) self);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp28_ = _tmp27_;
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp29_ = sqlite3_errmsg (_tmp28_);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp30_ = g_strdup_printf ("Failed to compile statement %s", _tmp29_);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp31_ = _tmp30_;
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp32_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp31_);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp33_ = _tmp32_;
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_g_free0 (_tmp31_);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_inner_error_ = _tmp33_;
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_propagate_error (error, _inner_error_);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_sqlite3_finalize0 (stmt);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile_v2);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (olddbfile);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				return;
#line 424 "midori-bookmarksdatabase.c"
			} else {
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_sqlite3_finalize0 (stmt);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile_v2);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (olddbfile);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_clear_error (&_inner_error_);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				return;
#line 440 "midori-bookmarksdatabase.c"
			}
		}
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp34_ = stmt;
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		if (sqlite3_step (_tmp34_) != SQLITE_ROW) {
#line 447 "midori-bookmarksdatabase.c"
			sqlite3* _tmp35_;
			sqlite3* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			GError* _tmp40_;
			GError* _tmp41_;
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp35_ = midori_database_get_db ((MidoriDatabase*) self);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp36_ = _tmp35_;
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp37_ = sqlite3_errmsg (_tmp36_);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp38_ = g_strdup_printf ("Failed to get row %s", _tmp37_);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp39_ = _tmp38_;
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp40_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp39_);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp41_ = _tmp40_;
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_g_free0 (_tmp39_);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_inner_error_ = _tmp41_;
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_propagate_error (error, _inner_error_);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_sqlite3_finalize0 (stmt);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile_v2);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (olddbfile);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				return;
#line 487 "midori-bookmarksdatabase.c"
			} else {
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_sqlite3_finalize0 (stmt);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile_v2);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (olddbfile);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (dbfile);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_clear_error (&_inner_error_);
#line 43 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				return;
#line 503 "midori-bookmarksdatabase.c"
			}
		}
#line 44 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp42_ = stmt;
#line 44 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		user_version = sqlite3_column_int64 (_tmp42_, 0);
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp43_ = user_version;
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		if (_tmp43_ == ((gint64) 0)) {
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			midori_database_exec ((MidoriDatabase*) self, "PRAGMA user_version = 1;", &_inner_error_);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_propagate_error (error, _inner_error_);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_sqlite3_finalize0 (stmt);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile_v2);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (olddbfile);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					return;
#line 532 "midori-bookmarksdatabase.c"
				} else {
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_sqlite3_finalize0 (stmt);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile_v2);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (olddbfile);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_clear_error (&_inner_error_);
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					return;
#line 548 "midori-bookmarksdatabase.c"
				}
			}
		}
#line 50 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_sqlite3_close0 (((MidoriDatabase*) self)->_db);
#line 50 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		((MidoriDatabase*) self)->_db = NULL;
#line 27 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_sqlite3_finalize0 (stmt);
#line 558 "midori-bookmarksdatabase.c"
	} else {
		const gchar* _tmp44_;
#line 51 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		_tmp44_ = dbfile;
#line 51 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
		if (g_file_test (_tmp44_, G_FILE_TEST_EXISTS)) {
#line 565 "midori-bookmarksdatabase.c"
			const gchar* _tmp45_;
			sqlite3* _tmp46_ = NULL;
			gint _tmp47_;
			sqlite3_stmt* stmt = NULL;
			sqlite3* _tmp54_;
			sqlite3* _tmp55_;
			sqlite3_stmt* _tmp56_ = NULL;
			gint _tmp57_;
			sqlite3_stmt* _tmp65_;
			gint64 user_version = 0LL;
			sqlite3_stmt* _tmp73_;
			gint64 _tmp74_;
#line 53 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp45_ = dbfile;
#line 53 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp47_ = sqlite3_open_v2 (_tmp45_, &_tmp46_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 53 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_sqlite3_close0 (((MidoriDatabase*) self)->_db);
#line 53 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			((MidoriDatabase*) self)->_db = _tmp46_;
#line 53 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			if (_tmp47_ != SQLITE_OK) {
#line 588 "midori-bookmarksdatabase.c"
				const gchar* _tmp48_;
				const gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				GError* _tmp52_;
				GError* _tmp53_;
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp48_ = midori_database_get_path ((MidoriDatabase*) self);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp49_ = _tmp48_;
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp50_ = g_strdup_printf ("Failed to open database %s", _tmp49_);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp51_ = _tmp50_;
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp52_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_OPEN, _tmp51_);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp53_ = _tmp52_;
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (_tmp51_);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_inner_error_ = _tmp53_;
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_propagate_error (error, _inner_error_);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile_v2);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (olddbfile);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					return;
#line 623 "midori-bookmarksdatabase.c"
				} else {
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile_v2);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (olddbfile);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_clear_error (&_inner_error_);
#line 54 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					return;
#line 637 "midori-bookmarksdatabase.c"
				}
			}
#line 57 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp54_ = midori_database_get_db ((MidoriDatabase*) self);
#line 57 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp55_ = _tmp54_;
#line 57 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp57_ = sqlite3_prepare_v2 (_tmp55_, "PRAGMA user_version;", -1, &_tmp56_, NULL);
#line 57 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_sqlite3_finalize0 (stmt);
#line 57 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			stmt = _tmp56_;
#line 57 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			if (_tmp57_ != SQLITE_OK) {
#line 652 "midori-bookmarksdatabase.c"
				sqlite3* _tmp58_;
				sqlite3* _tmp59_;
				const gchar* _tmp60_;
				gchar* _tmp61_;
				gchar* _tmp62_;
				GError* _tmp63_;
				GError* _tmp64_;
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp58_ = midori_database_get_db ((MidoriDatabase*) self);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp59_ = _tmp58_;
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp60_ = sqlite3_errmsg (_tmp59_);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp61_ = g_strdup_printf ("Failed to compile statement %s", _tmp60_);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp62_ = _tmp61_;
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp63_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp62_);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp64_ = _tmp63_;
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (_tmp62_);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_inner_error_ = _tmp64_;
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_propagate_error (error, _inner_error_);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_sqlite3_finalize0 (stmt);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile_v2);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (olddbfile);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					return;
#line 692 "midori-bookmarksdatabase.c"
				} else {
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_sqlite3_finalize0 (stmt);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile_v2);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (olddbfile);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_clear_error (&_inner_error_);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					return;
#line 708 "midori-bookmarksdatabase.c"
				}
			}
#line 59 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp65_ = stmt;
#line 59 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			if (sqlite3_step (_tmp65_) != SQLITE_ROW) {
#line 715 "midori-bookmarksdatabase.c"
				sqlite3* _tmp66_;
				sqlite3* _tmp67_;
				const gchar* _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
				GError* _tmp71_;
				GError* _tmp72_;
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp66_ = midori_database_get_db ((MidoriDatabase*) self);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp67_ = _tmp66_;
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp68_ = sqlite3_errmsg (_tmp67_);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp69_ = g_strdup_printf ("Failed to get row %s", _tmp68_);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp70_ = _tmp69_;
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp71_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp70_);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp72_ = _tmp71_;
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_g_free0 (_tmp70_);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_inner_error_ = _tmp72_;
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_propagate_error (error, _inner_error_);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_sqlite3_finalize0 (stmt);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile_v2);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (olddbfile);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					return;
#line 755 "midori-bookmarksdatabase.c"
				} else {
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_sqlite3_finalize0 (stmt);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile_v2);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (olddbfile);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (dbfile);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					g_clear_error (&_inner_error_);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					return;
#line 771 "midori-bookmarksdatabase.c"
				}
			}
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp73_ = stmt;
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			user_version = sqlite3_column_int64 (_tmp73_, 0);
#line 63 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_sqlite3_close0 (((MidoriDatabase*) self)->_db);
#line 63 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			((MidoriDatabase*) self)->_db = NULL;
#line 65 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_tmp74_ = user_version;
#line 65 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			if (_tmp74_ == ((gint64) 0)) {
#line 786 "midori-bookmarksdatabase.c"
				const gchar* _tmp75_;
				const gchar* _tmp77_;
				const gchar* _tmp78_;
				const gchar* _tmp79_;
				sqlite3* _tmp80_ = NULL;
				gint _tmp81_;
				const gchar* _tmp88_;
				gboolean failure = FALSE;
				gboolean _tmp92_;
#line 66 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp75_ = olddbfile;
#line 66 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (g_file_test (_tmp75_, G_FILE_TEST_EXISTS)) {
#line 800 "midori-bookmarksdatabase.c"
					const gchar* _tmp76_;
#line 67 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_tmp76_ = olddbfile;
#line 67 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					unlink (_tmp76_);
#line 806 "midori-bookmarksdatabase.c"
				}
#line 69 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp77_ = dbfile;
#line 69 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp78_ = olddbfile;
#line 69 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				g_rename (_tmp77_, _tmp78_);
#line 71 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp79_ = dbfile;
#line 71 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp81_ = sqlite3_open_v2 (_tmp79_, &_tmp80_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 71 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_sqlite3_close0 (((MidoriDatabase*) self)->_db);
#line 71 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				((MidoriDatabase*) self)->_db = _tmp80_;
#line 71 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (_tmp81_ != SQLITE_OK) {
#line 824 "midori-bookmarksdatabase.c"
					const gchar* _tmp82_;
					const gchar* _tmp83_;
					gchar* _tmp84_;
					gchar* _tmp85_;
					GError* _tmp86_;
					GError* _tmp87_;
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_tmp82_ = midori_database_get_path ((MidoriDatabase*) self);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_tmp83_ = _tmp82_;
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_tmp84_ = g_strdup_printf ("Failed to open database %s", _tmp83_);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_tmp85_ = _tmp84_;
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_tmp86_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_OPEN, _tmp85_);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_tmp87_ = _tmp86_;
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_free0 (_tmp85_);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_inner_error_ = _tmp87_;
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_propagate_error (error, _inner_error_);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 861 "midori-bookmarksdatabase.c"
					} else {
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_clear_error (&_inner_error_);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 877 "midori-bookmarksdatabase.c"
					}
				}
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				midori_database_exec_script ((MidoriDatabase*) self, "Create", &_inner_error_);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_propagate_error (error, _inner_error_);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 898 "midori-bookmarksdatabase.c"
					} else {
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_clear_error (&_inner_error_);
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 914 "midori-bookmarksdatabase.c"
					}
				}
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp88_ = olddbfile;
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				midori_database_attach ((MidoriDatabase*) self, _tmp88_, "old_db", &_inner_error_);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_propagate_error (error, _inner_error_);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 937 "midori-bookmarksdatabase.c"
					} else {
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_clear_error (&_inner_error_);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 953 "midori-bookmarksdatabase.c"
					}
				}
#line 78 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				failure = FALSE;
#line 958 "midori-bookmarksdatabase.c"
				{
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					midori_database_exec_script ((MidoriDatabase*) self, "Import_old_db_bookmarks", &_inner_error_);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 966 "midori-bookmarksdatabase.c"
							goto __catch11_midori_database_error;
						}
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_clear_error (&_inner_error_);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 983 "midori-bookmarksdatabase.c"
					}
				}
				goto __finally11;
				__catch11_midori_database_error:
				{
					GError* _error_ = NULL;
					GError* _tmp89_;
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_error_ = _inner_error_;
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_inner_error_ = NULL;
#line 82 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_tmp89_ = _error_;
#line 82 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					if (g_error_matches (_tmp89_, MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE)) {
#line 83 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						failure = TRUE;
#line 1001 "midori-bookmarksdatabase.c"
					} else {
						GError* _tmp90_;
						GError* _tmp91_;
#line 85 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_tmp90_ = _error_;
#line 85 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_tmp91_ = _g_error_copy0 (_tmp90_);
#line 85 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_inner_error_ = _tmp91_;
#line 85 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_error_free0 (_error_);
#line 1013 "midori-bookmarksdatabase.c"
						goto __finally11;
					}
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					_g_error_free0 (_error_);
#line 1018 "midori-bookmarksdatabase.c"
				}
				__finally11:
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_propagate_error (error, _inner_error_);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 1037 "midori-bookmarksdatabase.c"
					} else {
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_clear_error (&_inner_error_);
#line 79 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 1053 "midori-bookmarksdatabase.c"
					}
				}
#line 89 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_tmp92_ = failure;
#line 89 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (_tmp92_) {
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					midori_database_exec ((MidoriDatabase*) self, "ROLLBACK TRANSACTION;", &_inner_error_);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							g_propagate_error (error, _inner_error_);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							_sqlite3_finalize0 (stmt);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							_g_free0 (dbfile_v2);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							_g_free0 (olddbfile);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							_g_free0 (dbfile);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							return;
#line 1078 "midori-bookmarksdatabase.c"
						} else {
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							_sqlite3_finalize0 (stmt);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							_g_free0 (dbfile_v2);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							_g_free0 (olddbfile);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							_g_free0 (dbfile);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							g_clear_error (&_inner_error_);
#line 90 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
							return;
#line 1094 "midori-bookmarksdatabase.c"
						}
					}
				}
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				midori_database_exec ((MidoriDatabase*) self, "DETACH DATABASE old_db;", &_inner_error_);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_propagate_error (error, _inner_error_);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 1116 "midori-bookmarksdatabase.c"
					} else {
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_clear_error (&_inner_error_);
#line 92 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 1132 "midori-bookmarksdatabase.c"
					}
				}
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				midori_database_exec ((MidoriDatabase*) self, "PRAGMA user_version = 1;", &_inner_error_);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_propagate_error (error, _inner_error_);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 1153 "midori-bookmarksdatabase.c"
					} else {
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_sqlite3_finalize0 (stmt);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile_v2);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (olddbfile);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						_g_free0 (dbfile);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						g_clear_error (&_inner_error_);
#line 93 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
						return;
#line 1169 "midori-bookmarksdatabase.c"
					}
				}
#line 95 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				_sqlite3_close0 (((MidoriDatabase*) self)->_db);
#line 95 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
				((MidoriDatabase*) self)->_db = NULL;
#line 1176 "midori-bookmarksdatabase.c"
			}
#line 51 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
			_sqlite3_finalize0 (stmt);
#line 1180 "midori-bookmarksdatabase.c"
		}
	}
#line 22 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_g_free0 (dbfile_v2);
#line 22 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_g_free0 (olddbfile);
#line 22 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	_g_free0 (dbfile);
#line 1189 "midori-bookmarksdatabase.c"
}


static void
midori_bookmarks_database_class_init (MidoriBookmarksDatabaseClass * klass)
{
#line 14 "/builddir/build/BUILD/midori-0.5.12/midori/midori-bookmarksdatabase.vala"
	midori_bookmarks_database_parent_class = g_type_class_peek_parent (klass);
#line 1198 "midori-bookmarksdatabase.c"
}


static void
midori_bookmarks_database_instance_init (MidoriBookmarksDatabase * self)
{
}


GType
midori_bookmarks_database_get_type (void)
{
	static volatile gsize midori_bookmarks_database_type_id__volatile = 0;
	if (g_once_init_enter (&midori_bookmarks_database_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MidoriBookmarksDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) midori_bookmarks_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MidoriBookmarksDatabase), 0, (GInstanceInitFunc) midori_bookmarks_database_instance_init, NULL };
		GType midori_bookmarks_database_type_id;
		midori_bookmarks_database_type_id = g_type_register_static (MIDORI_TYPE_DATABASE, "MidoriBookmarksDatabase", &g_define_type_info, 0);
		g_once_init_leave (&midori_bookmarks_database_type_id__volatile, midori_bookmarks_database_type_id);
	}
	return midori_bookmarks_database_type_id__volatile;
}



