/* subscriptions.c generated by valac 0.40.7, the Vala compiler
 * generated from subscriptions.vala, do not modify */

/*
 Copyright (C) 2009-2014 Christian Dywan <christian@twotoasts.de>
 Copyright (C) 2009-2012 Alexander Butenko <a.butenka@gmail.com>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/


#include <glib.h>
#include <glib-object.h>
#include "toolbar-editor.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>
#include "midori-core.h"

enum  {
	ADBLOCK_FEATURE_0_PROPERTY,
	ADBLOCK_FEATURE_NUM_PROPERTIES
};
static GParamSpec* adblock_feature_properties[ADBLOCK_FEATURE_NUM_PROPERTIES];
enum  {
	ADBLOCK_SUBSCRIPTION_0_PROPERTY,
	ADBLOCK_SUBSCRIPTION_URI_PROPERTY,
	ADBLOCK_SUBSCRIPTION_TITLE_PROPERTY,
	ADBLOCK_SUBSCRIPTION_ACTIVE_PROPERTY,
	ADBLOCK_SUBSCRIPTION_MUTABLE_PROPERTY,
	ADBLOCK_SUBSCRIPTION_VALID_PROPERTY,
	ADBLOCK_SUBSCRIPTION_SIZE_PROPERTY,
	ADBLOCK_SUBSCRIPTION_NUM_PROPERTIES
};
static GParamSpec* adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AdblockSubscriptionPrivate {
	gboolean debug_parse;
	gchar* _uri;
	gchar* _title;
	gboolean _active;
	gboolean _mutable;
	gboolean _valid;
	GHashTable* cache;
	GList* features;
	guint _size;
};


static gpointer adblock_feature_parent_class = NULL;
static gpointer adblock_subscription_parent_class = NULL;

static gboolean adblock_feature_real_header (AdblockFeature* self,
                                      const gchar* key,
                                      const gchar* value);
static gboolean adblock_feature_real_parsed (AdblockFeature* self,
                                      GFile* file);
static AdblockDirective* adblock_feature_real_match (AdblockFeature* self,
                                              const gchar* request_uri,
                                              const gchar* page_uri,
                                              GError** error);
static void adblock_feature_real_clear (AdblockFeature* self);
#define ADBLOCK_SUBSCRIPTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), ADBLOCK_TYPE_SUBSCRIPTION, AdblockSubscriptionPrivate))
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void adblock_subscription_set_size (AdblockSubscription* self,
                                    guint value);
static void _g_free0_ (gpointer var);
void adblock_subscription_parse_line (AdblockSubscription* self,
                                      const gchar* line,
                                      GError** error);
static void adblock_subscription_add_url_pattern (AdblockSubscription* self,
                                           const gchar* prefix,
                                           const gchar* type,
                                           const gchar* line,
                                           GError** error);
static void adblock_subscription_frame_add_private (AdblockSubscription* self,
                                             const gchar* line,
                                             const gchar* sep);
static void adblock_subscription_update_css_hash (AdblockSubscription* self,
                                           const gchar* domain,
                                           const gchar* value);
static gboolean adblock_subscription_css_element_seems_valid (AdblockSubscription* self,
                                                       const gchar* element);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      gchar* needle);
gchar* adblock_fixup_regex (const gchar* prefix,
                            const gchar* src);
static gboolean adblock_subscription_compile_regexp (AdblockSubscription* self,
                                              const gchar* patt,
                                              const gchar* opts,
                                              GError** error);
void adblock_debug (const gchar* format,
                    ...);
static void adblock_subscription_set_valid (AdblockSubscription* self,
                                     gboolean value);
static AdblockDirective* _adblock_directive_dup (AdblockDirective* self);
static void adblock_subscription_finalize (GObject * obj);
static void _vala_adblock_subscription_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_adblock_subscription_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gboolean
adblock_feature_real_header (AdblockFeature* self,
                             const gchar* key,
                             const gchar* value)
{
	gboolean result = FALSE;
#line 15 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 15 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 16 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = FALSE;
#line 16 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 143 "subscriptions.c"
}


gboolean
adblock_feature_header (AdblockFeature* self,
                        const gchar* key,
                        const gchar* value)
{
#line 15 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 15 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return ADBLOCK_FEATURE_GET_CLASS (self)->header (self, key, value);
#line 156 "subscriptions.c"
}


static gboolean
adblock_feature_real_parsed (AdblockFeature* self,
                             GFile* file)
{
	gboolean result = FALSE;
#line 18 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 19 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = TRUE;
#line 19 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 171 "subscriptions.c"
}


gboolean
adblock_feature_parsed (AdblockFeature* self,
                        GFile* file)
{
#line 18 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 18 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return ADBLOCK_FEATURE_GET_CLASS (self)->parsed (self, file);
#line 183 "subscriptions.c"
}


static AdblockDirective*
adblock_feature_real_match (AdblockFeature* self,
                            const gchar* request_uri,
                            const gchar* page_uri,
                            GError** error)
{
	AdblockDirective* result = NULL;
#line 21 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (request_uri != NULL, NULL);
#line 21 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (page_uri != NULL, NULL);
#line 22 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = NULL;
#line 22 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 202 "subscriptions.c"
}


AdblockDirective*
adblock_feature_match (AdblockFeature* self,
                       const gchar* request_uri,
                       const gchar* page_uri,
                       GError** error)
{
#line 21 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return ADBLOCK_FEATURE_GET_CLASS (self)->match (self, request_uri, page_uri, error);
#line 216 "subscriptions.c"
}


static void
adblock_feature_real_clear (AdblockFeature* self)
{
}


void
adblock_feature_clear (AdblockFeature* self)
{
#line 24 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 24 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	ADBLOCK_FEATURE_GET_CLASS (self)->clear (self);
#line 233 "subscriptions.c"
}


AdblockFeature*
adblock_feature_construct (GType object_type)
{
	AdblockFeature * self = NULL;
#line 14 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self = (AdblockFeature*) g_object_new (object_type, NULL);
#line 14 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return self;
#line 245 "subscriptions.c"
}


static void
adblock_feature_class_init (AdblockFeatureClass * klass)
{
#line 14 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_feature_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	((AdblockFeatureClass *) klass)->header = (gboolean (*) (AdblockFeature *, const gchar*, const gchar*)) adblock_feature_real_header;
#line 14 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	((AdblockFeatureClass *) klass)->parsed = (gboolean (*) (AdblockFeature *, GFile*)) adblock_feature_real_parsed;
#line 14 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	((AdblockFeatureClass *) klass)->match = (AdblockDirective* (*) (AdblockFeature *, const gchar*, const gchar*, GError**)) adblock_feature_real_match;
#line 14 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	((AdblockFeatureClass *) klass)->clear = (void (*) (AdblockFeature *)) adblock_feature_real_clear;
#line 262 "subscriptions.c"
}


static void
adblock_feature_instance_init (AdblockFeature * self)
{
}


GType
adblock_feature_get_type (void)
{
	static volatile gsize adblock_feature_type_id__volatile = 0;
	if (g_once_init_enter (&adblock_feature_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AdblockFeatureClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adblock_feature_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdblockFeature), 0, (GInstanceInitFunc) adblock_feature_instance_init, NULL };
		GType adblock_feature_type_id;
		adblock_feature_type_id = g_type_register_static (G_TYPE_OBJECT, "AdblockFeature", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&adblock_feature_type_id__volatile, adblock_feature_type_id);
	}
	return adblock_feature_type_id__volatile;
}


static void
_g_object_unref0_ (gpointer var)
{
#line 37 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 291 "subscriptions.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 37 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 300 "subscriptions.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 320 "subscriptions.c"
}


AdblockSubscription*
adblock_subscription_construct (GType object_type,
                                const gchar* uri)
{
	AdblockSubscription * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	AdblockOptions* _tmp2_;
	AdblockOptions* _tmp3_;
	AdblockWhitelist* _tmp4_;
	AdblockWhitelist* _tmp5_;
	AdblockOptions* _tmp6_;
	AdblockKeys* _tmp7_;
	AdblockKeys* _tmp8_;
	AdblockOptions* _tmp9_;
	AdblockPattern* _tmp10_;
	AdblockPattern* _tmp11_;
	AdblockElement* _tmp12_;
	AdblockElement* _tmp13_;
#line 44 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 44 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self = (AdblockSubscription*) g_object_new (object_type, NULL);
#line 45 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp1_ = g_getenv ("MIDORI_DEBUG");
#line 45 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = _tmp1_;
#line 45 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp0_ == NULL) {
#line 45 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp0_ = "";
#line 355 "subscriptions.c"
	}
#line 45 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->priv->debug_parse = string_contains (_tmp0_, "adblock:parse");
#line 47 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_set_uri (self, uri);
#line 49 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp2_ = adblock_options_new ();
#line 49 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->optslist);
#line 49 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->optslist = _tmp2_;
#line 50 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp3_ = self->optslist;
#line 50 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp4_ = adblock_whitelist_new (_tmp3_);
#line 50 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->whitelist);
#line 50 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->whitelist = _tmp4_;
#line 51 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp5_ = self->whitelist;
#line 51 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_add_feature (self, (AdblockFeature*) _tmp5_);
#line 52 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp6_ = self->optslist;
#line 52 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp7_ = adblock_keys_new (_tmp6_);
#line 52 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->keys);
#line 52 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->keys = _tmp7_;
#line 53 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp8_ = self->keys;
#line 53 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_add_feature (self, (AdblockFeature*) _tmp8_);
#line 54 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp9_ = self->optslist;
#line 54 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp10_ = adblock_pattern_new (_tmp9_);
#line 54 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->pattern);
#line 54 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->pattern = _tmp10_;
#line 55 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp11_ = self->pattern;
#line 55 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_add_feature (self, (AdblockFeature*) _tmp11_);
#line 56 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp12_ = adblock_element_new ();
#line 56 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->element);
#line 56 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->element = _tmp12_;
#line 57 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp13_ = self->element;
#line 57 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_add_feature (self, (AdblockFeature*) _tmp13_);
#line 58 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_clear (self);
#line 44 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return self;
#line 417 "subscriptions.c"
}


AdblockSubscription*
adblock_subscription_new (const gchar* uri)
{
#line 44 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return adblock_subscription_construct (ADBLOCK_TYPE_SUBSCRIPTION, uri);
#line 426 "subscriptions.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 62 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return self ? g_object_ref (self) : NULL;
#line 435 "subscriptions.c"
}


void
adblock_subscription_add_feature (AdblockSubscription* self,
                                  AdblockFeature* feature)
{
	AdblockFeature* _tmp0_;
	guint _tmp1_;
#line 61 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 61 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (feature != NULL);
#line 62 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = _g_object_ref0 (feature);
#line 62 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->priv->features = g_list_append (self->priv->features, _tmp0_);
#line 63 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp1_ = self->priv->_size;
#line 63 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_set_size (self, _tmp1_ + 1);
#line 457 "subscriptions.c"
}


AdblockFeature*
adblock_subscription_get (AdblockSubscription* self,
                          guint index)
{
	AdblockFeature* result = NULL;
	GList* _tmp0_;
	gconstpointer _tmp1_;
#line 67 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = self->priv->features;
#line 68 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp1_ = g_list_nth_data (_tmp0_, index);
#line 68 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = (AdblockFeature*) _tmp1_;
#line 68 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 478 "subscriptions.c"
}


static void
_g_free0_ (gpointer var)
{
#line 73 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	var = (g_free (var), NULL);
#line 487 "subscriptions.c"
}


void
adblock_subscription_clear (AdblockSubscription* self)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GList* _tmp3_;
	AdblockOptions* _tmp5_;
#line 72 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 73 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = g_str_hash;
#line 73 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp1_ = g_str_equal;
#line 73 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 73 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_hash_table_unref0 (self->priv->cache);
#line 73 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->priv->cache = _tmp2_;
#line 74 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp3_ = self->priv->features;
#line 513 "subscriptions.c"
	{
		GList* feature_collection = NULL;
		GList* feature_it = NULL;
#line 74 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		feature_collection = _tmp3_;
#line 74 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		for (feature_it = feature_collection; feature_it != NULL; feature_it = feature_it->next) {
#line 521 "subscriptions.c"
			AdblockFeature* feature = NULL;
#line 74 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			feature = (AdblockFeature*) feature_it->data;
#line 525 "subscriptions.c"
			{
				AdblockFeature* _tmp4_;
#line 75 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp4_ = feature;
#line 75 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				adblock_feature_clear (_tmp4_);
#line 532 "subscriptions.c"
			}
		}
	}
#line 76 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp5_ = self->optslist;
#line 76 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_options_clear (_tmp5_);
#line 540 "subscriptions.c"
}


static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result = NULL;
#line 1163 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1164 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + offset);
#line 1164 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 555 "subscriptions.c"
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1124 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1125 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1125 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_;
#line 1125 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 573 "subscriptions.c"
}


void
adblock_subscription_parse_line (AdblockSubscription* self,
                                 const gchar* line,
                                 GError** error)
{
	GError * _inner_error_ = NULL;
#line 79 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 80 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (g_str_has_prefix (line, "@@")) {
#line 587 "subscriptions.c"
		gboolean _tmp0_ = FALSE;
#line 81 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (string_contains (line, "$")) {
#line 81 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp0_ = string_contains (line, "domain");
#line 593 "subscriptions.c"
		} else {
#line 81 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp0_ = FALSE;
#line 597 "subscriptions.c"
		}
#line 81 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp0_) {
#line 82 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			return;
#line 603 "subscriptions.c"
		}
#line 83 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (g_str_has_prefix (line, "@@||")) {
#line 607 "subscriptions.c"
			const gchar* _tmp1_;
#line 84 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp1_ = string_offset (line, (glong) 4);
#line 84 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			adblock_subscription_add_url_pattern (self, "^", "whitelist", _tmp1_, &_inner_error_);
#line 84 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 84 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				g_propagate_error (error, _inner_error_);
#line 84 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				return;
#line 619 "subscriptions.c"
			}
		} else {
#line 85 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (g_str_has_prefix (line, "@@|")) {
#line 624 "subscriptions.c"
				const gchar* _tmp2_;
#line 86 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp2_ = string_offset (line, (glong) 3);
#line 86 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				adblock_subscription_add_url_pattern (self, "^", "whitelist", _tmp2_, &_inner_error_);
#line 86 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 86 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					g_propagate_error (error, _inner_error_);
#line 86 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					return;
#line 636 "subscriptions.c"
				}
			} else {
				const gchar* _tmp3_;
#line 88 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp3_ = string_offset (line, (glong) 2);
#line 88 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				adblock_subscription_add_url_pattern (self, "", "whitelist", _tmp3_, &_inner_error_);
#line 88 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 88 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					g_propagate_error (error, _inner_error_);
#line 88 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					return;
#line 650 "subscriptions.c"
				}
			}
		}
#line 89 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 656 "subscriptions.c"
	}
#line 92 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (string_get (line, (glong) 0) == '[') {
#line 93 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 662 "subscriptions.c"
	}
#line 96 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (g_str_has_prefix (line, "##")) {
#line 98 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 668 "subscriptions.c"
	}
#line 100 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (string_get (line, (glong) 0) == '#') {
#line 101 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 674 "subscriptions.c"
	}
#line 104 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (string_contains (line, "#@#")) {
#line 105 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 680 "subscriptions.c"
	}
#line 108 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (string_contains (line, "##")) {
#line 109 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_frame_add_private (self, line, "##");
#line 110 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 688 "subscriptions.c"
	}
#line 112 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (string_contains (line, "#")) {
#line 113 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_frame_add_private (self, line, "#");
#line 114 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 696 "subscriptions.c"
	}
#line 118 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (g_str_has_prefix (line, "|")) {
#line 120 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (string_contains (line, "$")) {
#line 121 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			return;
#line 704 "subscriptions.c"
		}
#line 123 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (g_str_has_prefix (line, "||")) {
#line 708 "subscriptions.c"
			const gchar* _tmp4_;
#line 124 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp4_ = string_offset (line, (glong) 2);
#line 124 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			adblock_subscription_add_url_pattern (self, "", "fulluri", _tmp4_, &_inner_error_);
#line 124 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 124 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				g_propagate_error (error, _inner_error_);
#line 124 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				return;
#line 720 "subscriptions.c"
			}
		} else {
			const gchar* _tmp5_;
#line 126 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp5_ = string_offset (line, (glong) 1);
#line 126 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			adblock_subscription_add_url_pattern (self, "^", "fulluri", _tmp5_, &_inner_error_);
#line 126 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 126 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				g_propagate_error (error, _inner_error_);
#line 126 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				return;
#line 734 "subscriptions.c"
			}
		}
#line 127 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 739 "subscriptions.c"
	}
#line 130 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_add_url_pattern (self, "", "uri", line, &_inner_error_);
#line 130 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 130 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_propagate_error (error, _inner_error_);
#line 130 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 749 "subscriptions.c"
	}
#line 131 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return;
#line 753 "subscriptions.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 778 "subscriptions.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1336 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1336 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	end = _tmp0_;
#line 1337 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = end;
#line 1337 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1338 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = maxlen;
#line 1338 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 802 "subscriptions.c"
	} else {
		gchar* _tmp2_;
#line 1340 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = end;
#line 1340 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1340 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 811 "subscriptions.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1347 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 832 "subscriptions.c"
	} else {
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 836 "subscriptions.c"
	}
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1351 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 842 "subscriptions.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1353 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1353 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1353 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 852 "subscriptions.c"
	}
#line 1356 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 856 "subscriptions.c"
		glong _tmp3_;
#line 1357 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1357 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1358 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 864 "subscriptions.c"
	} else {
		glong _tmp4_;
#line 1360 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1360 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 871 "subscriptions.c"
	}
#line 1362 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 875 "subscriptions.c"
		glong _tmp5_;
#line 1363 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1363 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 881 "subscriptions.c"
	}
#line 1365 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1365 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1366 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1366 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp7_;
#line 1366 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 893 "subscriptions.c"
}


static void
adblock_subscription_frame_add_private (AdblockSubscription* self,
                                        const gchar* line,
                                        const gchar* sep)
{
	gchar** data = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint data_length1;
	gint _data_size_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gchar** _tmp5_;
	gint _tmp5__length1;
	const gchar* _tmp6_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
#line 134 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 134 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (line != NULL);
#line 134 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (sep != NULL);
#line 135 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp1_ = _tmp0_ = g_strsplit (line, sep, 2);
#line 135 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	data = _tmp1_;
#line 135 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	data_length1 = _vala_array_length (_tmp0_);
#line 135 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_data_size_ = data_length1;
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp5_ = data;
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp5__length1 = data_length1;
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp6_ = _tmp5_[1];
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp6_ != NULL) {
#line 939 "subscriptions.c"
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp7_ = data;
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp7__length1 = data_length1;
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp8_ = _tmp7_[1];
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp4_ = g_strcmp0 (_tmp8_, "") != 0;
#line 951 "subscriptions.c"
	} else {
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp4_ = FALSE;
#line 955 "subscriptions.c"
	}
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (!_tmp4_) {
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp3_ = TRUE;
#line 961 "subscriptions.c"
	} else {
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 137 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp9_ = data;
#line 137 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp9__length1 = data_length1;
#line 137 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp10_ = _tmp9_[1];
#line 137 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp11_ = g_utf8_strchr (_tmp10_, (gssize) -1, (gunichar) '\'');
#line 137 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp3_ = _tmp11_ != NULL;
#line 977 "subscriptions.c"
	}
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp3_) {
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp2_ = TRUE;
#line 983 "subscriptions.c"
	} else {
		gboolean _tmp12_ = FALSE;
		gchar** _tmp13_;
		gint _tmp13__length1;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 138 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp13_ = data;
#line 138 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp13__length1 = data_length1;
#line 138 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp14_ = _tmp13_[1];
#line 138 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp15_ = g_utf8_strchr (_tmp14_, (gssize) -1, (gunichar) ':');
#line 138 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp15_ != NULL) {
#line 1000 "subscriptions.c"
			gchar** _tmp16_;
			gint _tmp16__length1;
			const gchar* _tmp17_;
#line 139 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp16_ = data;
#line 139 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp16__length1 = data_length1;
#line 139 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp17_ = _tmp16_[1];
#line 139 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp12_ = !g_regex_match_simple (".*\\[.*:.*\\].*", _tmp17_, G_REGEX_CASELESS, G_REGEX_MATCH_NOTEMPTY);
#line 1012 "subscriptions.c"
		} else {
#line 138 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp12_ = FALSE;
#line 1016 "subscriptions.c"
		}
#line 138 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp2_ = _tmp12_;
#line 1020 "subscriptions.c"
	}
#line 136 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp2_) {
#line 141 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 141 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 1028 "subscriptions.c"
	}
#line 144 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp18_ = data;
#line 144 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp18__length1 = data_length1;
#line 144 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp19_ = _tmp18_[0];
#line 144 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp20_ = g_utf8_strchr (_tmp19_, (gssize) -1, (gunichar) ',');
#line 144 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp20_ != NULL) {
#line 1040 "subscriptions.c"
		gchar** domains = NULL;
		gchar** _tmp21_;
		gint _tmp21__length1;
		const gchar* _tmp22_;
		gchar** _tmp23_;
		gchar** _tmp24_;
		gint domains_length1;
		gint _domains_size_;
		gchar** _tmp25_;
		gint _tmp25__length1;
#line 145 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp21_ = data;
#line 145 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp21__length1 = data_length1;
#line 145 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp22_ = _tmp21_[0];
#line 145 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp24_ = _tmp23_ = g_strsplit (_tmp22_, ",", -1);
#line 145 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		domains = _tmp24_;
#line 145 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		domains_length1 = _vala_array_length (_tmp23_);
#line 145 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_domains_size_ = domains_length1;
#line 147 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp25_ = domains;
#line 147 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp25__length1 = domains_length1;
#line 1069 "subscriptions.c"
		{
			gchar** domain_collection = NULL;
			gint domain_collection_length1 = 0;
			gint _domain_collection_size_ = 0;
			gint domain_it = 0;
#line 147 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			domain_collection = _tmp25_;
#line 147 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			domain_collection_length1 = _tmp25__length1;
#line 147 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			for (domain_it = 0; domain_it < _tmp25__length1; domain_it = domain_it + 1) {
#line 1081 "subscriptions.c"
				const gchar* domain = NULL;
#line 147 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				domain = domain_collection[domain_it];
#line 1085 "subscriptions.c"
				{
					const gchar* _tmp26_;
					gchar* stripped = NULL;
					const gchar* _tmp27_;
					gchar* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp32_;
					gchar** _tmp33_;
					gint _tmp33__length1;
					const gchar* _tmp34_;
#line 149 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp26_ = domain;
#line 149 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					if (g_strcmp0 (_tmp26_, "~pregecko2") == 0) {
#line 150 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						continue;
#line 1102 "subscriptions.c"
					}
#line 151 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp27_ = domain;
#line 151 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp28_ = string_strip (_tmp27_);
#line 151 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					stripped = _tmp28_;
#line 153 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp29_ = stripped;
#line 153 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					if (string_get (_tmp29_, (glong) 0) == '~') {
#line 1114 "subscriptions.c"
						const gchar* _tmp30_;
						gchar* _tmp31_;
#line 154 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp30_ = stripped;
#line 154 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp31_ = string_substring (_tmp30_, (glong) 1, (glong) -1);
#line 154 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_g_free0 (stripped);
#line 154 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						stripped = _tmp31_;
#line 1125 "subscriptions.c"
					}
#line 155 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp32_ = stripped;
#line 155 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp33_ = data;
#line 155 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp33__length1 = data_length1;
#line 155 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp34_ = _tmp33_[1];
#line 155 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					adblock_subscription_update_css_hash (self, _tmp32_, _tmp34_);
#line 147 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_g_free0 (stripped);
#line 1139 "subscriptions.c"
				}
			}
		}
#line 144 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		domains = (_vala_array_free (domains, domains_length1, (GDestroyNotify) g_free), NULL);
#line 1145 "subscriptions.c"
	} else {
		gchar** _tmp35_;
		gint _tmp35__length1;
		const gchar* _tmp36_;
		gchar** _tmp37_;
		gint _tmp37__length1;
		const gchar* _tmp38_;
#line 159 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp35_ = data;
#line 159 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp35__length1 = data_length1;
#line 159 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp36_ = _tmp35_[0];
#line 159 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp37_ = data;
#line 159 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp37__length1 = data_length1;
#line 159 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp38_ = _tmp37_[1];
#line 159 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_update_css_hash (self, _tmp36_, _tmp38_);
#line 1167 "subscriptions.c"
	}
#line 134 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 1171 "subscriptions.c"
}


static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             gchar* needle)
{
	int i;
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	for (i = 0; i < stack_length; i++) {
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			return TRUE;
#line 1187 "subscriptions.c"
		}
	}
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return FALSE;
#line 1192 "subscriptions.c"
}


static gboolean
adblock_subscription_css_element_seems_valid (AdblockSubscription* self,
                                              const gchar* element)
{
	gboolean result = FALSE;
	gboolean is_valid = FALSE;
	gchar** valid_elements = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar** _tmp65_;
	gint valid_elements_length1;
	gint _valid_elements_size_;
	gboolean _tmp66_ = FALSE;
	gboolean _tmp67_ = FALSE;
	const gchar* _tmp73_ = NULL;
	const gchar* _tmp74_;
	gboolean debug_selectors = FALSE;
	gboolean _tmp75_;
#line 163 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (element != NULL, FALSE);
#line 164 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	is_valid = TRUE;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = g_strdup ("::after");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp1_ = g_strdup ("::before");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp2_ = g_strdup ("a");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp3_ = g_strdup ("abbr");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp4_ = g_strdup ("address");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp5_ = g_strdup ("article");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp6_ = g_strdup ("aside");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp7_ = g_strdup ("b");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp8_ = g_strdup ("blockquote");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp9_ = g_strdup ("caption");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp10_ = g_strdup ("center");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp11_ = g_strdup ("cite");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp12_ = g_strdup ("code");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp13_ = g_strdup ("div");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp14_ = g_strdup ("dl");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp15_ = g_strdup ("dt");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp16_ = g_strdup ("dd");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp17_ = g_strdup ("em");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp18_ = g_strdup ("feed");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp19_ = g_strdup ("fieldset");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp20_ = g_strdup ("figcaption");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp21_ = g_strdup ("figure");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp22_ = g_strdup ("font");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp23_ = g_strdup ("footer");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp24_ = g_strdup ("form");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp25_ = g_strdup ("h1");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp26_ = g_strdup ("h2");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp27_ = g_strdup ("h3");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp28_ = g_strdup ("h4");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp29_ = g_strdup ("h5");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp30_ = g_strdup ("h6");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp31_ = g_strdup ("header");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp32_ = g_strdup ("hgroup");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp33_ = g_strdup ("i");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp34_ = g_strdup ("iframe");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp35_ = g_strdup ("iframe html *");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp36_ = g_strdup ("img");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp37_ = g_strdup ("kbd");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp38_ = g_strdup ("label");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp39_ = g_strdup ("legend");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp40_ = g_strdup ("li");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp41_ = g_strdup ("m");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp42_ = g_strdup ("main");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp43_ = g_strdup ("marquee");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp44_ = g_strdup ("menu");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp45_ = g_strdup ("nav");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp46_ = g_strdup ("ol");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp47_ = g_strdup ("option");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp48_ = g_strdup ("p");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp49_ = g_strdup ("pre");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp50_ = g_strdup ("q");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp51_ = g_strdup ("samp");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp52_ = g_strdup ("section");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp53_ = g_strdup ("small");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp54_ = g_strdup ("span");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp55_ = g_strdup ("strong");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp56_ = g_strdup ("summary");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp57_ = g_strdup ("table");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp58_ = g_strdup ("tr");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp59_ = g_strdup ("tbody");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp60_ = g_strdup ("td");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp61_ = g_strdup ("th");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp62_ = g_strdup ("thead");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp63_ = g_strdup ("tt");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp64_ = g_strdup ("ul");
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_ = g_new0 (gchar*, 65 + 1);
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[0] = _tmp0_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[1] = _tmp1_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[2] = _tmp2_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[3] = _tmp3_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[4] = _tmp4_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[5] = _tmp5_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[6] = _tmp6_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[7] = _tmp7_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[8] = _tmp8_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[9] = _tmp9_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[10] = _tmp10_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[11] = _tmp11_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[12] = _tmp12_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[13] = _tmp13_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[14] = _tmp14_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[15] = _tmp15_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[16] = _tmp16_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[17] = _tmp17_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[18] = _tmp18_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[19] = _tmp19_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[20] = _tmp20_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[21] = _tmp21_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[22] = _tmp22_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[23] = _tmp23_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[24] = _tmp24_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[25] = _tmp25_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[26] = _tmp26_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[27] = _tmp27_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[28] = _tmp28_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[29] = _tmp29_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[30] = _tmp30_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[31] = _tmp31_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[32] = _tmp32_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[33] = _tmp33_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[34] = _tmp34_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[35] = _tmp35_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[36] = _tmp36_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[37] = _tmp37_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[38] = _tmp38_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[39] = _tmp39_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[40] = _tmp40_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[41] = _tmp41_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[42] = _tmp42_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[43] = _tmp43_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[44] = _tmp44_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[45] = _tmp45_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[46] = _tmp46_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[47] = _tmp47_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[48] = _tmp48_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[49] = _tmp49_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[50] = _tmp50_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[51] = _tmp51_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[52] = _tmp52_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[53] = _tmp53_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[54] = _tmp54_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[55] = _tmp55_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[56] = _tmp56_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[57] = _tmp57_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[58] = _tmp58_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[59] = _tmp59_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[60] = _tmp60_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[61] = _tmp61_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[62] = _tmp62_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[63] = _tmp63_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp65_[64] = _tmp64_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	valid_elements = _tmp65_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	valid_elements_length1 = 65;
#line 165 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_valid_elements_size_ = valid_elements_length1;
#line 172 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (!g_str_has_prefix (element, ".")) {
#line 172 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp67_ = !g_str_has_prefix (element, "#");
#line 1555 "subscriptions.c"
	} else {
#line 172 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp67_ = FALSE;
#line 1559 "subscriptions.c"
	}
#line 172 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp67_) {
#line 1563 "subscriptions.c"
		gchar** _tmp68_;
		gchar** _tmp69_;
		gchar** _tmp70_;
		gint _tmp70__length1;
		const gchar* _tmp71_;
		gchar** _tmp72_;
		gint _tmp72__length1;
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp69_ = _tmp68_ = g_strsplit (element, "[", 0);
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp70_ = _tmp69_;
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp70__length1 = _vala_array_length (_tmp68_);
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp71_ = _tmp70_[0];
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp72_ = valid_elements;
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp72__length1 = valid_elements_length1;
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp66_ = !_vala_string_array_contains (_tmp72_, _tmp72__length1, _tmp71_);
#line 173 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp70_ = (_vala_array_free (_tmp70_, _tmp70__length1, (GDestroyNotify) g_free), NULL);
#line 1587 "subscriptions.c"
	} else {
#line 172 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp66_ = FALSE;
#line 1591 "subscriptions.c"
	}
#line 172 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp66_) {
#line 174 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		is_valid = FALSE;
#line 1597 "subscriptions.c"
	}
#line 177 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp74_ = g_getenv ("MIDORI_DEBUG");
#line 177 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp73_ = _tmp74_;
#line 177 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp73_ == NULL) {
#line 177 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp73_ = "";
#line 1607 "subscriptions.c"
	}
#line 177 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	debug_selectors = string_contains (_tmp73_, "adblock:css");
#line 178 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp75_ = debug_selectors;
#line 178 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp75_) {
#line 1615 "subscriptions.c"
		const gchar* _tmp76_ = NULL;
		gboolean _tmp77_;
		FILE* _tmp78_;
		const gchar* _tmp79_;
#line 180 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp77_ = is_valid;
#line 180 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp77_) {
#line 180 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp76_ = "selector";
#line 1626 "subscriptions.c"
		} else {
#line 180 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp76_ = "INVALID?";
#line 1630 "subscriptions.c"
		}
#line 179 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp78_ = stdout;
#line 179 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp79_ = self->priv->_title;
#line 179 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		fprintf (_tmp78_, "Adblock '%s' %s: %s\n", _tmp79_, _tmp76_, element);
#line 1638 "subscriptions.c"
	}
#line 182 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = is_valid;
#line 182 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	valid_elements = (_vala_array_free (valid_elements, valid_elements_length1, (GDestroyNotify) g_free), NULL);
#line 182 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 1646 "subscriptions.c"
}


static void
adblock_subscription_update_css_hash (AdblockSubscription* self,
                                      const gchar* domain,
                                      const gchar* value)
{
#line 185 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 185 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (domain != NULL);
#line 185 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (value != NULL);
#line 186 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (adblock_subscription_css_element_seems_valid (self, value)) {
#line 1663 "subscriptions.c"
		gchar* olddata = NULL;
		AdblockElement* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 187 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp0_ = self->element;
#line 187 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp1_ = adblock_element_lookup (_tmp0_, domain);
#line 187 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		olddata = _tmp1_;
#line 188 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp2_ = olddata;
#line 188 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp2_ != NULL) {
#line 1678 "subscriptions.c"
			gchar* newdata = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			AdblockElement* _tmp8_;
			const gchar* _tmp9_;
#line 189 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp3_ = olddata;
#line 189 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp4_ = g_strconcat (_tmp3_, " , ", NULL);
#line 189 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp5_ = _tmp4_;
#line 189 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp6_ = g_strconcat (_tmp5_, value, NULL);
#line 189 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp7_ = _tmp6_;
#line 189 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (_tmp5_);
#line 189 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			newdata = _tmp7_;
#line 190 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp8_ = self->element;
#line 190 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp9_ = newdata;
#line 190 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			adblock_element_insert (_tmp8_, domain, _tmp9_);
#line 188 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (newdata);
#line 1709 "subscriptions.c"
		} else {
			AdblockElement* _tmp10_;
#line 192 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp10_ = self->element;
#line 192 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			adblock_element_insert (_tmp10_, domain, value);
#line 1716 "subscriptions.c"
		}
#line 186 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (olddata);
#line 1720 "subscriptions.c"
	}
}


static void
adblock_subscription_add_url_pattern (AdblockSubscription* self,
                                      const gchar* prefix,
                                      const gchar* type,
                                      const gchar* line,
                                      GError** error)
{
	gchar** data = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint data_length1;
	gint _data_size_;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* patt = NULL;
	gchar* opts = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	const gchar* _tmp17_;
	gchar* format_patt = NULL;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	GError * _inner_error_ = NULL;
#line 197 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 197 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (prefix != NULL);
#line 197 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (type != NULL);
#line 197 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (line != NULL);
#line 198 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp1_ = _tmp0_ = g_strsplit (line, "$", 2);
#line 198 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	data = _tmp1_;
#line 198 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	data_length1 = _vala_array_length (_tmp0_);
#line 198 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_data_size_ = data_length1;
#line 199 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp3_ = data;
#line 199 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp3__length1 = data_length1;
#line 199 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp3_ == NULL) {
#line 199 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp2_ = TRUE;
#line 1782 "subscriptions.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
		const gchar* _tmp5_;
#line 199 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp4_ = data;
#line 199 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp4__length1 = data_length1;
#line 199 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp5_ = _tmp4_[0];
#line 199 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp2_ = _tmp5_ == NULL;
#line 1795 "subscriptions.c"
	}
#line 199 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp2_) {
#line 200 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 200 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 1803 "subscriptions.c"
	}
#line 203 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp6_ = data;
#line 203 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp6__length1 = data_length1;
#line 203 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp7_ = _tmp6_[0];
#line 203 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 203 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (patt);
#line 203 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	patt = _tmp8_;
#line 204 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp9_ = g_strdup (type);
#line 204 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (opts);
#line 204 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	opts = _tmp9_;
#line 206 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp10_ = data;
#line 206 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp10__length1 = data_length1;
#line 206 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp11_ = _tmp10_[1];
#line 206 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp11_ != NULL) {
#line 1831 "subscriptions.c"
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 207 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp12_ = g_strconcat (type, ",", NULL);
#line 207 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp13_ = _tmp12_;
#line 207 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp14_ = data;
#line 207 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp14__length1 = data_length1;
#line 207 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp15_ = _tmp14_[1];
#line 207 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp16_ = g_strconcat (_tmp13_, _tmp15_, NULL);
#line 207 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (opts);
#line 207 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		opts = _tmp16_;
#line 207 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (_tmp13_);
#line 1856 "subscriptions.c"
	}
#line 209 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp17_ = opts;
#line 209 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (g_regex_match_simple ("subdocument", _tmp17_, G_REGEX_CASELESS, G_REGEX_MATCH_NOTEMPTY)) {
#line 211 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (opts);
#line 211 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (patt);
#line 211 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 211 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 1870 "subscriptions.c"
	}
#line 213 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp18_ = patt;
#line 213 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp19_ = adblock_fixup_regex (prefix, _tmp18_);
#line 213 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	format_patt = _tmp19_;
#line 214 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp20_ = self->priv->debug_parse;
#line 214 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (_tmp20_) {
#line 1882 "subscriptions.c"
		FILE* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 215 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp21_ = stdout;
#line 215 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp22_ = format_patt;
#line 215 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp23_ = opts;
#line 215 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		fprintf (_tmp21_, "got: %s opts %s\n", _tmp22_, _tmp23_);
#line 1894 "subscriptions.c"
	}
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp24_ = format_patt;
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp25_ = opts;
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_compile_regexp (self, _tmp24_, _tmp25_, &_inner_error_);
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_propagate_error (error, _inner_error_);
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (format_patt);
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (opts);
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (patt);
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 216 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 1916 "subscriptions.c"
	}
#line 197 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (format_patt);
#line 197 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (opts);
#line 197 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (patt);
#line 197 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 1926 "subscriptions.c"
}


static gboolean
adblock_subscription_compile_regexp (AdblockSubscription* self,
                                     const gchar* patt,
                                     const gchar* opts,
                                     GError** error)
{
	gboolean result = FALSE;
	gboolean _tmp47_ = FALSE;
	GError * _inner_error_ = NULL;
#line 220 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 220 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (opts != NULL, FALSE);
#line 221 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (patt == NULL) {
#line 222 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		result = FALSE;
#line 222 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return result;
#line 1949 "subscriptions.c"
	}
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
		gboolean _tmp1_ = FALSE;
#line 224 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp0_ = g_regex_new (patt, G_REGEX_OPTIMIZE, G_REGEX_MATCH_NOTEMPTY, &_inner_error_);
#line 224 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		regex = _tmp0_;
#line 224 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1961 "subscriptions.c"
			goto __catch15_g_error;
		}
#line 226 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (g_regex_match_simple ("^/.*[\\^\\$\\*].*/$", patt, G_REGEX_UNGREEDY, G_REGEX_MATCH_NOTEMPTY)) {
#line 226 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp1_ = TRUE;
#line 1968 "subscriptions.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 228 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (opts != NULL) {
#line 228 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp2_ = string_contains (opts, "whitelist");
#line 1975 "subscriptions.c"
			} else {
#line 228 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp2_ = FALSE;
#line 1979 "subscriptions.c"
			}
#line 228 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp1_ = _tmp2_;
#line 1983 "subscriptions.c"
		}
#line 226 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp1_) {
#line 1987 "subscriptions.c"
			gboolean _tmp3_;
			AdblockOptions* _tmp9_;
#line 229 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp3_ = self->priv->debug_parse;
#line 229 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (_tmp3_) {
#line 1994 "subscriptions.c"
				FILE* _tmp4_;
#line 230 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp4_ = stdout;
#line 230 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				fprintf (_tmp4_, "patt: %s\n", patt);
#line 2000 "subscriptions.c"
			}
#line 231 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (string_contains (opts, "whitelist")) {
#line 2004 "subscriptions.c"
				AdblockWhitelist* _tmp5_;
				GRegex* _tmp6_;
#line 232 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp5_ = self->whitelist;
#line 232 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp6_ = regex;
#line 232 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				adblock_filter_insert ((AdblockFilter*) _tmp5_, patt, _tmp6_);
#line 2013 "subscriptions.c"
			} else {
				AdblockPattern* _tmp7_;
				GRegex* _tmp8_;
#line 234 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp7_ = self->pattern;
#line 234 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp8_ = regex;
#line 234 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				adblock_filter_insert ((AdblockFilter*) _tmp7_, patt, _tmp8_);
#line 2023 "subscriptions.c"
			}
#line 235 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp9_ = self->optslist;
#line 235 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			adblock_options_insert (_tmp9_, patt, opts);
#line 236 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			result = FALSE;
#line 236 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_regex_unref0 (regex);
#line 236 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			return result;
#line 2035 "subscriptions.c"
		} else {
			gint pos = 0;
			gint len = 0;
			gint signature_size = 0;
			gchar* sig = NULL;
			gint _tmp10_;
			gint _tmp11_;
#line 238 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			pos = 0;
#line 239 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			signature_size = 8;
#line 241 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp10_ = strlen (patt);
#line 241 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp11_ = _tmp10_;
#line 241 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			len = _tmp11_;
#line 2053 "subscriptions.c"
			{
				gint _tmp12_;
				gint _tmp13_;
				gboolean _tmp14_ = FALSE;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp12_ = len;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp13_ = signature_size;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				pos = _tmp12_ - _tmp13_;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp14_ = TRUE;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				while (TRUE) {
#line 2068 "subscriptions.c"
					gint _tmp16_;
					gint _tmp17_;
					const gchar* _tmp18_;
					gint _tmp19_;
					gchar* _tmp20_;
					gboolean _tmp21_ = FALSE;
					const gchar* _tmp22_;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					if (!_tmp14_) {
#line 2078 "subscriptions.c"
						gint _tmp15_;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp15_ = pos;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						pos = _tmp15_ - 1;
#line 2084 "subscriptions.c"
					}
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp14_ = FALSE;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp16_ = pos;
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					if (!(_tmp16_ >= 0)) {
#line 244 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						break;
#line 2094 "subscriptions.c"
					}
#line 246 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp17_ = pos;
#line 246 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp18_ = string_offset (patt, (glong) _tmp17_);
#line 246 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp19_ = signature_size;
#line 246 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp20_ = g_strndup (_tmp18_, (gsize) _tmp19_);
#line 246 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_g_free0 (sig);
#line 246 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					sig = _tmp20_;
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp22_ = sig;
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					if (!g_regex_match_simple ("[\\*]", _tmp22_, G_REGEX_UNGREEDY, G_REGEX_MATCH_NOTEMPTY)) {
#line 2112 "subscriptions.c"
						AdblockKeys* _tmp23_;
						const gchar* _tmp24_;
						GRegex* _tmp25_;
						GRegex* _tmp26_;
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp23_ = self->keys;
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp24_ = sig;
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp25_ = adblock_filter_lookup ((AdblockFilter*) _tmp23_, _tmp24_);
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp26_ = _tmp25_;
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp21_ = _tmp26_ == NULL;
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_g_regex_unref0 (_tmp26_);
#line 2129 "subscriptions.c"
					} else {
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp21_ = FALSE;
#line 2133 "subscriptions.c"
					}
#line 248 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					if (_tmp21_) {
#line 2137 "subscriptions.c"
						AdblockKeys* _tmp27_;
						const gchar* _tmp28_;
						GRegex* _tmp29_;
						AdblockOptions* _tmp30_;
						const gchar* _tmp31_;
#line 249 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp27_ = self->keys;
#line 249 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp28_ = sig;
#line 249 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp29_ = regex;
#line 249 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						adblock_filter_insert ((AdblockFilter*) _tmp27_, _tmp28_, _tmp29_);
#line 250 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp30_ = self->optslist;
#line 250 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp31_ = sig;
#line 250 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						adblock_options_insert (_tmp30_, _tmp31_, opts);
#line 2157 "subscriptions.c"
					} else {
						gboolean _tmp32_ = FALSE;
						gboolean _tmp33_ = FALSE;
						const gchar* _tmp34_;
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp34_ = sig;
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						if (g_str_has_prefix (_tmp34_, "*")) {
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp33_ = TRUE;
#line 2168 "subscriptions.c"
						} else {
							const gchar* _tmp35_;
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp35_ = sig;
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp33_ = g_str_has_prefix (_tmp35_, "\\");
#line 2175 "subscriptions.c"
						}
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						if (_tmp33_) {
#line 2179 "subscriptions.c"
							AdblockPattern* _tmp36_;
							const gchar* _tmp37_;
							GRegex* _tmp38_;
							GRegex* _tmp39_;
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp36_ = self->pattern;
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp37_ = sig;
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp38_ = adblock_filter_lookup ((AdblockFilter*) _tmp36_, _tmp37_);
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp39_ = _tmp38_;
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp32_ = _tmp39_ == NULL;
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_g_regex_unref0 (_tmp39_);
#line 2196 "subscriptions.c"
						} else {
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp32_ = FALSE;
#line 2200 "subscriptions.c"
						}
#line 253 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						if (_tmp32_) {
#line 2204 "subscriptions.c"
							AdblockPattern* _tmp40_;
							const gchar* _tmp41_;
							GRegex* _tmp42_;
							AdblockOptions* _tmp43_;
							const gchar* _tmp44_;
#line 254 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp40_ = self->pattern;
#line 254 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp41_ = sig;
#line 254 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp42_ = regex;
#line 254 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							adblock_filter_insert ((AdblockFilter*) _tmp40_, _tmp41_, _tmp42_);
#line 255 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp43_ = self->optslist;
#line 255 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							_tmp44_ = sig;
#line 255 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
							adblock_options_insert (_tmp43_, _tmp44_, opts);
#line 2224 "subscriptions.c"
						}
					}
				}
			}
#line 226 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (sig);
#line 2231 "subscriptions.c"
		}
#line 260 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		result = FALSE;
#line 260 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_regex_unref0 (regex);
#line 260 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return result;
#line 2239 "subscriptions.c"
	}
	goto __finally15;
	__catch15_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp45_;
		const gchar* _tmp46_;
#line 223 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_error_ = _inner_error_;
#line 223 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_inner_error_ = NULL;
#line 263 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp45_ = _error_;
#line 263 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp46_ = _tmp45_->message;
#line 263 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_warning ("subscriptions.vala:263: Adblock compile regexp: %s", _tmp46_);
#line 264 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		result = TRUE;
#line 264 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_error_free0 (_error_);
#line 264 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return result;
#line 2263 "subscriptions.c"
	}
	__finally15:
#line 223 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_propagate_error (error, _inner_error_);
#line 223 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return _tmp47_;
#line 2270 "subscriptions.c"
}


void
adblock_subscription_parse_header (AdblockSubscription* self,
                                   const gchar* header,
                                   GError** error)
{
	gchar* key = NULL;
	gchar* _tmp0_;
	gchar* value = NULL;
	gchar* _tmp1_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	GList* _tmp25_;
#line 268 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 268 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (header != NULL);
#line 273 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = g_strdup (header);
#line 273 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	key = _tmp0_;
#line 274 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp1_ = g_strdup ("");
#line 274 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	value = _tmp1_;
#line 275 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (string_contains (header, ":")) {
#line 2301 "subscriptions.c"
		gchar** parts = NULL;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint parts_length1;
		gint _parts_size_;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
#line 276 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp3_ = _tmp2_ = g_strsplit (header, ":", 2);
#line 276 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		parts = _tmp3_;
#line 276 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		parts_length1 = _vala_array_length (_tmp2_);
#line 276 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_parts_size_ = parts_length1;
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp7_ = parts;
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp7__length1 = parts_length1;
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp8_ = _tmp7_[0];
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp8_ != NULL) {
#line 2329 "subscriptions.c"
			gchar** _tmp9_;
			gint _tmp9__length1;
			const gchar* _tmp10_;
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp9_ = parts;
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp9__length1 = parts_length1;
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp10_ = _tmp9_[0];
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp6_ = g_strcmp0 (_tmp10_, "") != 0;
#line 2341 "subscriptions.c"
		} else {
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp6_ = FALSE;
#line 2345 "subscriptions.c"
		}
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp6_) {
#line 2349 "subscriptions.c"
			gchar** _tmp11_;
			gint _tmp11__length1;
			const gchar* _tmp12_;
#line 278 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp11_ = parts;
#line 278 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp11__length1 = parts_length1;
#line 278 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp12_ = _tmp11_[1];
#line 278 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp5_ = _tmp12_ != NULL;
#line 2361 "subscriptions.c"
		} else {
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp5_ = FALSE;
#line 2365 "subscriptions.c"
		}
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp5_) {
#line 2369 "subscriptions.c"
			gchar** _tmp13_;
			gint _tmp13__length1;
			const gchar* _tmp14_;
#line 278 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp13_ = parts;
#line 278 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp13__length1 = parts_length1;
#line 278 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp14_ = _tmp13_[1];
#line 278 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp4_ = g_strcmp0 (_tmp14_, "") != 0;
#line 2381 "subscriptions.c"
		} else {
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp4_ = FALSE;
#line 2385 "subscriptions.c"
		}
#line 277 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp4_) {
#line 2389 "subscriptions.c"
			gchar** _tmp15_;
			gint _tmp15__length1;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar** _tmp18_;
			gint _tmp18__length1;
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 279 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp15_ = parts;
#line 279 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp15__length1 = parts_length1;
#line 279 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp16_ = _tmp15_[0];
#line 279 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp17_ = string_substring (_tmp16_, (glong) 2, (glong) -1);
#line 279 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (key);
#line 279 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			key = _tmp17_;
#line 280 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp18_ = parts;
#line 280 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp18__length1 = parts_length1;
#line 280 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp19_ = _tmp18_[1];
#line 280 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp20_ = string_substring (_tmp19_, (glong) 1, (glong) -1);
#line 280 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (value);
#line 280 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			value = _tmp20_;
#line 2422 "subscriptions.c"
		}
#line 275 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 2426 "subscriptions.c"
	}
#line 283 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp21_ = key;
#line 283 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp22_ = value;
#line 283 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_debug ("Header '%s' says '%s'", _tmp21_, _tmp22_, NULL);
#line 284 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp23_ = key;
#line 284 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (g_strcmp0 (_tmp23_, "Title") == 0) {
#line 2438 "subscriptions.c"
		const gchar* _tmp24_;
#line 285 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp24_ = value;
#line 285 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_set_title (self, _tmp24_);
#line 2444 "subscriptions.c"
	}
#line 286 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp25_ = self->priv->features;
#line 2448 "subscriptions.c"
	{
		GList* feature_collection = NULL;
		GList* feature_it = NULL;
#line 286 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		feature_collection = _tmp25_;
#line 286 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		for (feature_it = feature_collection; feature_it != NULL; feature_it = feature_it->next) {
#line 2456 "subscriptions.c"
			AdblockFeature* feature = NULL;
#line 286 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			feature = (AdblockFeature*) feature_it->data;
#line 2460 "subscriptions.c"
			{
				AdblockFeature* _tmp26_;
				const gchar* _tmp27_;
				const gchar* _tmp28_;
#line 287 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp26_ = feature;
#line 287 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp27_ = key;
#line 287 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp28_ = value;
#line 287 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				if (adblock_feature_header (_tmp26_, _tmp27_, _tmp28_)) {
#line 288 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					break;
#line 2475 "subscriptions.c"
				}
			}
		}
	}
#line 268 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (value);
#line 268 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (key);
#line 2484 "subscriptions.c"
}


static gchar*
string_chomp (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1232 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1233 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1233 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1234 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1234 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strchomp (_tmp1_);
#line 1235 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1235 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 2509 "subscriptions.c"
}


void
adblock_subscription_parse (AdblockSubscription* self,
                            GError** error)
{
	gboolean _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* filter_file = NULL;
	const gchar* _tmp16_;
	GFile* _tmp17_;
	GDataInputStream* stream = NULL;
	gchar* line = NULL;
	GList* _tmp34_;
	GError * _inner_error_ = NULL;
#line 292 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 294 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = self->priv->_active;
#line 294 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (!_tmp0_) {
#line 295 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 2536 "subscriptions.c"
	}
#line 297 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp1_ = self->priv->_uri;
#line 297 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp2_ = self->path;
#line 297 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_debug ("Parsing %s (%s)", _tmp1_, _tmp2_, NULL);
#line 299 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_clear (self);
#line 301 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp3_ = self->priv->_uri;
#line 301 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (g_str_has_prefix (_tmp3_, "file://")) {
#line 2550 "subscriptions.c"
		gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp5_ = self->priv->_uri;
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp6_ = g_filename_from_uri (_tmp5_, NULL, &_inner_error_);
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp4_ = _tmp6_;
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			g_propagate_error (error, _inner_error_);
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			return;
#line 2567 "subscriptions.c"
		}
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp7_ = _tmp4_;
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp4_ = NULL;
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (self->path);
#line 302 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		self->path = _tmp7_;
#line 301 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (_tmp4_);
#line 2579 "subscriptions.c"
	} else {
		gchar* cache_dir = NULL;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* filename = NULL;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 304 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp8_ = g_get_user_cache_dir ();
#line 304 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp9_ = g_build_filename (_tmp8_, PACKAGE_NAME, "adblock", NULL);
#line 304 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		cache_dir = _tmp9_;
#line 305 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp10_ = cache_dir;
#line 305 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		midori_paths_mkdir_with_parents (_tmp10_, 0700);
#line 306 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp11_ = self->priv->_uri;
#line 306 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp12_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, _tmp11_, (gsize) -1);
#line 306 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		filename = _tmp12_;
#line 307 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp13_ = cache_dir;
#line 307 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp14_ = filename;
#line 307 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp15_ = g_build_filename (_tmp13_, _tmp14_, NULL);
#line 307 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (self->path);
#line 307 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		self->path = _tmp15_;
#line 301 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (filename);
#line 301 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (cache_dir);
#line 2621 "subscriptions.c"
	}
#line 310 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp16_ = self->path;
#line 310 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp17_ = g_file_new_for_path (_tmp16_);
#line 310 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	filter_file = _tmp17_;
#line 2629 "subscriptions.c"
	{
		GFileInputStream* _tmp18_ = NULL;
		GFile* _tmp19_;
		GFileInputStream* _tmp20_;
		GDataInputStream* _tmp21_;
#line 313 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp19_ = filter_file;
#line 313 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp20_ = g_file_read (_tmp19_, NULL, &_inner_error_);
#line 313 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp18_ = _tmp20_;
#line 313 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 313 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (g_error_matches (_inner_error_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 2645 "subscriptions.c"
				goto __catch16_g_io_error_not_found;
			}
			goto __finally16;
		}
#line 313 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp21_ = g_data_input_stream_new ((GInputStream*) _tmp18_);
#line 313 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_object_unref0 (stream);
#line 313 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		stream = _tmp21_;
#line 312 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_object_unref0 (_tmp18_);
#line 2658 "subscriptions.c"
	}
	goto __finally16;
	__catch16_g_io_error_not_found:
	{
		GError* exist_error = NULL;
#line 312 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		exist_error = _inner_error_;
#line 312 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_inner_error_ = NULL;
#line 316 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_error_free0 (exist_error);
#line 316 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_object_unref0 (stream);
#line 316 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_object_unref0 (filter_file);
#line 316 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 2676 "subscriptions.c"
	}
	__finally16:
#line 312 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 312 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_propagate_error (error, _inner_error_);
#line 312 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_object_unref0 (stream);
#line 312 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_object_unref0 (filter_file);
#line 312 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 2689 "subscriptions.c"
	}
#line 319 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_set_valid (self, FALSE);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	while (TRUE) {
#line 2695 "subscriptions.c"
		gchar* _tmp22_ = NULL;
		GDataInputStream* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* chomped = NULL;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp23_ = stream;
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp24_ = g_data_input_stream_read_line (_tmp23_, NULL, NULL, &_inner_error_);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp22_ = _tmp24_;
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			g_propagate_error (error, _inner_error_);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (line);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_object_unref0 (stream);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_object_unref0 (filter_file);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			return;
#line 2725 "subscriptions.c"
		}
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp25_ = _tmp22_;
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp22_ = NULL;
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (line);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		line = _tmp25_;
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp26_ = line;
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (!(_tmp26_ != NULL)) {
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (_tmp22_);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			break;
#line 2743 "subscriptions.c"
		}
#line 322 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp27_ = line;
#line 322 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp27_ == NULL) {
#line 323 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (_tmp22_);
#line 323 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			continue;
#line 2753 "subscriptions.c"
		}
#line 324 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp28_ = line;
#line 324 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp29_ = string_chomp (_tmp28_);
#line 324 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		chomped = _tmp29_;
#line 325 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp30_ = chomped;
#line 325 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (g_strcmp0 (_tmp30_, "") == 0) {
#line 326 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (chomped);
#line 326 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_free0 (_tmp22_);
#line 326 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			continue;
#line 2771 "subscriptions.c"
		}
#line 327 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp31_ = line;
#line 327 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (string_get (_tmp31_, (glong) 0) == '!') {
#line 2777 "subscriptions.c"
			const gchar* _tmp32_;
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp32_ = chomped;
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			adblock_subscription_parse_header (self, _tmp32_, &_inner_error_);
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				g_propagate_error (error, _inner_error_);
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_free0 (chomped);
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_free0 (_tmp22_);
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_free0 (line);
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_object_unref0 (stream);
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_object_unref0 (filter_file);
#line 328 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				return;
#line 2799 "subscriptions.c"
			}
		} else {
			const gchar* _tmp33_;
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_tmp33_ = chomped;
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			adblock_subscription_parse_line (self, _tmp33_, &_inner_error_);
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				g_propagate_error (error, _inner_error_);
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_free0 (chomped);
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_free0 (_tmp22_);
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_free0 (line);
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_object_unref0 (stream);
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_g_object_unref0 (filter_file);
#line 330 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				return;
#line 2823 "subscriptions.c"
			}
		}
#line 332 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_set_valid (self, TRUE);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (chomped);
#line 321 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (_tmp22_);
#line 2832 "subscriptions.c"
	}
#line 335 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp34_ = self->priv->features;
#line 2836 "subscriptions.c"
	{
		GList* feature_collection = NULL;
		GList* feature_it = NULL;
#line 335 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		feature_collection = _tmp34_;
#line 335 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		for (feature_it = feature_collection; feature_it != NULL; feature_it = feature_it->next) {
#line 2844 "subscriptions.c"
			AdblockFeature* feature = NULL;
#line 335 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			feature = (AdblockFeature*) feature_it->data;
#line 2848 "subscriptions.c"
			{
				AdblockFeature* _tmp35_;
				GFile* _tmp36_;
#line 336 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp35_ = feature;
#line 336 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				_tmp36_ = filter_file;
#line 336 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				if (!adblock_feature_parsed (_tmp35_, _tmp36_)) {
#line 337 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					adblock_subscription_set_valid (self, FALSE);
#line 2860 "subscriptions.c"
				}
			}
		}
	}
#line 292 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (line);
#line 292 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (stream);
#line 292 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (filter_file);
#line 2871 "subscriptions.c"
}


static AdblockDirective*
_adblock_directive_dup (AdblockDirective* self)
{
	AdblockDirective* dup;
#line 343 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	dup = g_new0 (AdblockDirective, 1);
#line 343 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	memcpy (dup, self, sizeof (AdblockDirective));
#line 343 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return dup;
#line 2885 "subscriptions.c"
}


static gpointer
__adblock_directive_dup0 (gpointer self)
{
#line 343 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return self ? _adblock_directive_dup (self) : NULL;
#line 2894 "subscriptions.c"
}


AdblockDirective*
adblock_subscription_get_directive (AdblockSubscription* self,
                                    const gchar* request_uri,
                                    const gchar* page_uri)
{
	AdblockDirective* result = NULL;
	GError * _inner_error_ = NULL;
#line 341 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 341 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (request_uri != NULL, NULL);
#line 341 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (page_uri != NULL, NULL);
#line 2911 "subscriptions.c"
	{
		AdblockDirective* directive = NULL;
		GHashTable* _tmp0_;
		gconstpointer _tmp1_;
		AdblockDirective* _tmp2_;
		AdblockDirective* _tmp3_;
		GList* _tmp4_;
#line 343 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp0_ = self->priv->cache;
#line 343 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp1_ = g_hash_table_lookup (_tmp0_, request_uri);
#line 343 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp2_ = __adblock_directive_dup0 ((AdblockDirective*) _tmp1_);
#line 343 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		directive = _tmp2_;
#line 344 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp3_ = directive;
#line 344 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (_tmp3_ != NULL) {
#line 345 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			result = directive;
#line 345 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			return result;
#line 2935 "subscriptions.c"
		}
#line 346 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp4_ = self->priv->features;
#line 2939 "subscriptions.c"
		{
			GList* feature_collection = NULL;
			GList* feature_it = NULL;
#line 346 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			feature_collection = _tmp4_;
#line 346 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			for (feature_it = feature_collection; feature_it != NULL; feature_it = feature_it->next) {
#line 2947 "subscriptions.c"
				AdblockFeature* feature = NULL;
#line 346 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
				feature = (AdblockFeature*) feature_it->data;
#line 2951 "subscriptions.c"
				{
					AdblockDirective* _tmp5_ = NULL;
					AdblockFeature* _tmp6_;
					AdblockDirective* _tmp7_;
					AdblockDirective* _tmp8_;
					AdblockDirective* _tmp9_;
#line 347 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp6_ = feature;
#line 347 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp7_ = adblock_feature_match (_tmp6_, request_uri, page_uri, &_inner_error_);
#line 347 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp5_ = _tmp7_;
#line 347 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 347 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_g_free0 (directive);
#line 2968 "subscriptions.c"
						goto __catch17_g_error;
					}
#line 347 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp8_ = _tmp5_;
#line 347 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp5_ = NULL;
#line 347 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_g_free0 (directive);
#line 347 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					directive = _tmp8_;
#line 348 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_tmp9_ = directive;
#line 348 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					if (_tmp9_ != NULL) {
#line 2983 "subscriptions.c"
						AdblockFeature* _tmp10_;
						const gchar* _tmp11_;
						AdblockDirective* _tmp12_;
						GEnumValue* _tmp13_;
#line 349 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp10_ = feature;
#line 349 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp11_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp10_));
#line 349 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp12_ = directive;
#line 350 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_tmp13_ = g_enum_get_value (g_type_class_ref (ADBLOCK_TYPE_DIRECTIVE), *_tmp12_);
#line 349 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						adblock_debug ("%s gave %s for %s (%s)\n", _tmp11_, (_tmp13_ != NULL) ? _tmp13_->value_name : NULL, request_uri, page_uri, NULL);
#line 351 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						result = directive;
#line 351 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						_g_free0 (_tmp5_);
#line 351 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
						return result;
#line 3004 "subscriptions.c"
					}
#line 346 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
					_g_free0 (_tmp5_);
#line 3008 "subscriptions.c"
				}
			}
		}
#line 342 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (directive);
#line 3014 "subscriptions.c"
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 342 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_error_ = _inner_error_;
#line 342 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_inner_error_ = NULL;
#line 355 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp14_ = _error_;
#line 355 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp15_ = _tmp14_->message;
#line 355 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_warning ("subscriptions.vala:355: Adblock match error: %s\n", _tmp15_);
#line 342 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_error_free0 (_error_);
#line 3034 "subscriptions.c"
	}
	__finally17:
#line 342 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 342 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 342 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_clear_error (&_inner_error_);
#line 342 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return NULL;
#line 3045 "subscriptions.c"
	}
#line 357 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = NULL;
#line 357 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 3051 "subscriptions.c"
}


static guint8*
string_get_data (const gchar* self,
                 int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 1442 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res = (guint8*) self;
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 3098 "subscriptions.c"
	}
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 3104 "subscriptions.c"
}


void
adblock_subscription_add_rule (AdblockSubscription* self,
                               const gchar* rule)
{
	GError * _inner_error_ = NULL;
#line 360 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 360 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (rule != NULL);
#line 3117 "subscriptions.c"
	{
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFileOutputStream* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileOutputStream* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		guint8* _tmp7_;
		gint _tmp7__length1;
		guint8* _tmp8_;
		gint _tmp8__length1;
#line 362 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp0_ = self->priv->_uri;
#line 362 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp1_ = g_file_new_for_uri (_tmp0_);
#line 362 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		file = _tmp1_;
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp3_ = file;
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp4_ = g_file_append_to (_tmp3_, G_FILE_CREATE_NONE, NULL, &_inner_error_);
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp2_ = _tmp4_;
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_object_unref0 (file);
#line 3147 "subscriptions.c"
			goto __catch18_g_error;
		}
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp5_ = g_strdup_printf ("%s\n", rule);
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp6_ = _tmp5_;
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp7_ = string_get_data (_tmp6_, &_tmp7__length1);
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp8_ = _tmp7_;
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp8__length1 = _tmp7__length1;
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_output_stream_write ((GOutputStream*) _tmp2_, _tmp8_, (gsize) _tmp8__length1, NULL, &_inner_error_);
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (_tmp6_);
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_object_unref0 (_tmp2_);
#line 363 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_object_unref0 (file);
#line 3170 "subscriptions.c"
			goto __catch18_g_error;
		}
#line 364 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_parse (self, &_inner_error_);
#line 364 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 364 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_object_unref0 (_tmp2_);
#line 364 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
			_g_object_unref0 (file);
#line 3181 "subscriptions.c"
			goto __catch18_g_error;
		}
#line 361 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_object_unref0 (_tmp2_);
#line 361 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_object_unref0 (file);
#line 3188 "subscriptions.c"
	}
	goto __finally18;
	__catch18_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 361 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_error_ = _inner_error_;
#line 361 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_inner_error_ = NULL;
#line 366 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp9_ = _error_;
#line 366 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp10_ = _tmp9_->message;
#line 366 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_warning ("subscriptions.vala:366: Failed to add custom rule: %s", _tmp10_);
#line 361 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_error_free0 (_error_);
#line 3208 "subscriptions.c"
	}
	__finally18:
#line 361 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 361 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 361 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_clear_error (&_inner_error_);
#line 361 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		return;
#line 3219 "subscriptions.c"
	}
}


const gchar*
adblock_subscription_get_uri (AdblockSubscription* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = self->priv->_uri;
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 3237 "subscriptions.c"
}


void
adblock_subscription_set_uri (AdblockSubscription* self,
                              const gchar* value)
{
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (g_strcmp0 (value, adblock_subscription_get_uri (self)) != 0) {
#line 3249 "subscriptions.c"
		gchar* _tmp0_;
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp0_ = g_strdup (value);
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (self->priv->_uri);
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		self->priv->_uri = _tmp0_;
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_object_notify_by_pspec ((GObject *) self, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_URI_PROPERTY]);
#line 3259 "subscriptions.c"
	}
}


const gchar*
adblock_subscription_get_title (AdblockSubscription* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = self->priv->_title;
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 3277 "subscriptions.c"
}


void
adblock_subscription_set_title (AdblockSubscription* self,
                                const gchar* value)
{
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (g_strcmp0 (value, adblock_subscription_get_title (self)) != 0) {
#line 3289 "subscriptions.c"
		gchar* _tmp0_;
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_tmp0_ = g_strdup (value);
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		_g_free0 (self->priv->_title);
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		self->priv->_title = _tmp0_;
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_object_notify_by_pspec ((GObject *) self, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_TITLE_PROPERTY]);
#line 3299 "subscriptions.c"
	}
}


gboolean
adblock_subscription_get_active (AdblockSubscription* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = self->priv->_active;
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 3317 "subscriptions.c"
}


void
adblock_subscription_set_active (AdblockSubscription* self,
                                 gboolean value)
{
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (adblock_subscription_get_active (self) != value) {
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		self->priv->_active = value;
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_object_notify_by_pspec ((GObject *) self, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_ACTIVE_PROPERTY]);
#line 3333 "subscriptions.c"
	}
}


gboolean
adblock_subscription_get_mutable (AdblockSubscription* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = self->priv->_mutable;
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 3351 "subscriptions.c"
}


void
adblock_subscription_set_mutable (AdblockSubscription* self,
                                  gboolean value)
{
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (adblock_subscription_get_mutable (self) != value) {
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		self->priv->_mutable = value;
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_object_notify_by_pspec ((GObject *) self, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_MUTABLE_PROPERTY]);
#line 3367 "subscriptions.c"
	}
}


gboolean
adblock_subscription_get_valid (AdblockSubscription* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = self->priv->_valid;
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 3385 "subscriptions.c"
}


static void
adblock_subscription_set_valid (AdblockSubscription* self,
                                gboolean value)
{
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (adblock_subscription_get_valid (self) != value) {
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		self->priv->_valid = value;
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_object_notify_by_pspec ((GObject *) self, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_VALID_PROPERTY]);
#line 3401 "subscriptions.c"
	}
}


guint
adblock_subscription_get_size (AdblockSubscription* self)
{
	guint result;
	guint _tmp0_;
#line 70 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 70 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_tmp0_ = self->priv->_size;
#line 70 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	result = _tmp0_;
#line 70 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	return result;
#line 3419 "subscriptions.c"
}


static void
adblock_subscription_set_size (AdblockSubscription* self,
                               guint value)
{
#line 70 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_return_if_fail (self != NULL);
#line 70 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	if (adblock_subscription_get_size (self) != value) {
#line 70 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		self->priv->_size = value;
#line 70 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_object_notify_by_pspec ((GObject *) self, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_SIZE_PROPERTY]);
#line 3435 "subscriptions.c"
	}
}


static void
adblock_subscription_class_init (AdblockSubscriptionClass * klass)
{
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	adblock_subscription_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_type_class_add_private (klass, sizeof (AdblockSubscriptionPrivate));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_adblock_subscription_get_property;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_adblock_subscription_set_property;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	G_OBJECT_CLASS (klass)->finalize = adblock_subscription_finalize;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADBLOCK_SUBSCRIPTION_URI_PROPERTY, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADBLOCK_SUBSCRIPTION_TITLE_PROPERTY, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADBLOCK_SUBSCRIPTION_ACTIVE_PROPERTY, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADBLOCK_SUBSCRIPTION_MUTABLE_PROPERTY, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_MUTABLE_PROPERTY] = g_param_spec_boolean ("mutable", "mutable", "mutable", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADBLOCK_SUBSCRIPTION_VALID_PROPERTY, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_VALID_PROPERTY] = g_param_spec_boolean ("valid", "valid", "valid", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADBLOCK_SUBSCRIPTION_SIZE_PROPERTY, adblock_subscription_properties[ADBLOCK_SUBSCRIPTION_SIZE_PROPERTY] = g_param_spec_uint ("size", "size", "size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3465 "subscriptions.c"
}


static void
adblock_subscription_instance_init (AdblockSubscription * self)
{
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->priv = ADBLOCK_SUBSCRIPTION_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->priv->_uri = NULL;
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->priv->_title = NULL;
#line 33 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->priv->_active = TRUE;
#line 34 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->priv->_mutable = TRUE;
#line 35 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self->priv->_valid = TRUE;
#line 3484 "subscriptions.c"
}


static void
adblock_subscription_finalize (GObject * obj)
{
	AdblockSubscription * self;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ADBLOCK_TYPE_SUBSCRIPTION, AdblockSubscription);
#line 29 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (self->path);
#line 31 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (self->priv->_uri);
#line 32 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_free0 (self->priv->_title);
#line 36 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_hash_table_unref0 (self->priv->cache);
#line 37 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	(self->priv->features == NULL) ? NULL : (self->priv->features = (_g_list_free__g_object_unref0_ (self->priv->features), NULL));
#line 38 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->pattern);
#line 39 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->keys);
#line 40 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->optslist);
#line 41 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->whitelist);
#line 42 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	_g_object_unref0 (self->element);
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	G_OBJECT_CLASS (adblock_subscription_parent_class)->finalize (obj);
#line 3516 "subscriptions.c"
}


GType
adblock_subscription_get_type (void)
{
	static volatile gsize adblock_subscription_type_id__volatile = 0;
	if (g_once_init_enter (&adblock_subscription_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AdblockSubscriptionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adblock_subscription_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdblockSubscription), 0, (GInstanceInitFunc) adblock_subscription_instance_init, NULL };
		GType adblock_subscription_type_id;
		adblock_subscription_type_id = g_type_register_static (G_TYPE_OBJECT, "AdblockSubscription", &g_define_type_info, 0);
		g_once_init_leave (&adblock_subscription_type_id__volatile, adblock_subscription_type_id);
	}
	return adblock_subscription_type_id__volatile;
}


static void
_vala_adblock_subscription_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	AdblockSubscription * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ADBLOCK_TYPE_SUBSCRIPTION, AdblockSubscription);
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_URI_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_value_set_string (value, adblock_subscription_get_uri (self));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_TITLE_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_value_set_string (value, adblock_subscription_get_title (self));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_ACTIVE_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_value_set_boolean (value, adblock_subscription_get_active (self));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_MUTABLE_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_value_set_boolean (value, adblock_subscription_get_mutable (self));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_VALID_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_value_set_boolean (value, adblock_subscription_get_valid (self));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_SIZE_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		g_value_set_uint (value, adblock_subscription_get_size (self));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 3580 "subscriptions.c"
		default:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 3586 "subscriptions.c"
	}
}


static void
_vala_adblock_subscription_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	AdblockSubscription * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ADBLOCK_TYPE_SUBSCRIPTION, AdblockSubscription);
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_URI_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_set_uri (self, g_value_get_string (value));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_TITLE_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_set_title (self, g_value_get_string (value));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_ACTIVE_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_set_active (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_MUTABLE_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_set_mutable (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_VALID_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_set_valid (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		case ADBLOCK_SUBSCRIPTION_SIZE_PROPERTY:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		adblock_subscription_set_size (self, g_value_get_uint (value));
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 3637 "subscriptions.c"
		default:
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/midori-0.5.12/extensions/adblock/subscriptions.vala"
		break;
#line 3643 "subscriptions.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



