/* midori-database.c generated by valac 0.40.7, the Vala compiler
 * generated from midori-database.vala, do not modify */

/*
 Copyright (C) 2013 Christian Dywan <christian@twotoats.de>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <glib/gstdio.h>


#define MIDORI_TYPE_DATABASE_STATEMENT (midori_database_statement_get_type ())
#define MIDORI_DATABASE_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatement))
#define MIDORI_DATABASE_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatementClass))
#define MIDORI_IS_DATABASE_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDORI_TYPE_DATABASE_STATEMENT))
#define MIDORI_IS_DATABASE_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDORI_TYPE_DATABASE_STATEMENT))
#define MIDORI_DATABASE_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatementClass))

typedef struct _MidoriDatabaseStatement MidoriDatabaseStatement;
typedef struct _MidoriDatabaseStatementClass MidoriDatabaseStatementClass;
typedef struct _MidoriDatabaseStatementPrivate MidoriDatabaseStatementPrivate;

#define MIDORI_TYPE_DATABASE (midori_database_get_type ())
#define MIDORI_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDORI_TYPE_DATABASE, MidoriDatabase))
#define MIDORI_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MIDORI_TYPE_DATABASE, MidoriDatabaseClass))
#define MIDORI_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDORI_TYPE_DATABASE))
#define MIDORI_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDORI_TYPE_DATABASE))
#define MIDORI_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDORI_TYPE_DATABASE, MidoriDatabaseClass))

typedef struct _MidoriDatabase MidoriDatabase;
typedef struct _MidoriDatabaseClass MidoriDatabaseClass;
enum  {
	MIDORI_DATABASE_STATEMENT_0_PROPERTY,
	MIDORI_DATABASE_STATEMENT_STMT_PROPERTY,
	MIDORI_DATABASE_STATEMENT_DATABASE_PROPERTY,
	MIDORI_DATABASE_STATEMENT_QUERY_PROPERTY,
	MIDORI_DATABASE_STATEMENT_NUM_PROPERTIES
};
static GParamSpec* midori_database_statement_properties[MIDORI_DATABASE_STATEMENT_NUM_PROPERTIES];
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MidoriDatabasePrivate MidoriDatabasePrivate;
enum  {
	MIDORI_DATABASE_0_PROPERTY,
	MIDORI_DATABASE_DB_PROPERTY,
	MIDORI_DATABASE_PATH_PROPERTY,
	MIDORI_DATABASE_FIRST_USE_PROPERTY,
	MIDORI_DATABASE_NUM_PROPERTIES
};
static GParamSpec* midori_database_properties[MIDORI_DATABASE_NUM_PROPERTIES];
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;

typedef enum  {
	MIDORI_DATABASE_ERROR_OPEN,
	MIDORI_DATABASE_ERROR_NAMING,
	MIDORI_DATABASE_ERROR_FILENAME,
	MIDORI_DATABASE_ERROR_EXECUTE,
	MIDORI_DATABASE_ERROR_COMPILE,
	MIDORI_DATABASE_ERROR_TYPE
} MidoriDatabaseError;
#define MIDORI_DATABASE_ERROR midori_database_error_quark ()
typedef gboolean (*MidoriDatabaseCallback) (gpointer user_data, GError** error);
struct _MidoriDatabaseStatement {
	GObject parent_instance;
	MidoriDatabaseStatementPrivate * priv;
	sqlite3_stmt* _stmt;
};

struct _MidoriDatabaseStatementClass {
	GObjectClass parent_class;
	gboolean (*init) (MidoriDatabaseStatement* self, GCancellable* cancellable, GError** error);
};

struct _MidoriDatabaseStatementPrivate {
	MidoriDatabase* _database;
	gchar* _query;
	gint64 last_row_id;
};

struct _MidoriDatabase {
	GObject parent_instance;
	MidoriDatabasePrivate * priv;
	gboolean trace;
	sqlite3* _db;
};

struct _MidoriDatabaseClass {
	GObjectClass parent_class;
	gboolean (*init) (MidoriDatabase* self, GCancellable* cancellable, GError** error);
};

struct _MidoriDatabasePrivate {
	gchar* _path;
	gboolean _first_use;
};

struct _Block3Data {
	int _ref_count_;
	MidoriDatabase* self;
	gchar* schema;
};


static gpointer midori_database_statement_parent_class = NULL;
static GInitableIface * midori_database_statement_g_initable_parent_iface = NULL;
static gpointer midori_database_parent_class = NULL;
static GInitableIface * midori_database_g_initable_parent_iface = NULL;

GQuark midori_database_error_quark (void);
GType midori_database_statement_get_type (void) G_GNUC_CONST;
GType midori_database_get_type (void) G_GNUC_CONST;
#define MIDORI_DATABASE_STATEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatementPrivate))
MidoriDatabaseStatement* midori_database_statement_new (MidoriDatabase* database,
                                                        const gchar* query,
                                                        GError** error);
MidoriDatabaseStatement* midori_database_statement_construct (GType object_type,
                                                              MidoriDatabase* database,
                                                              const gchar* query,
                                                              GError** error);
gboolean midori_database_statement_init (MidoriDatabaseStatement* self,
                                         GCancellable* cancellable,
                                         GError** error);
static gboolean midori_database_statement_real_init (MidoriDatabaseStatement* self,
                                              GCancellable* cancellable,
                                              GError** error);
MidoriDatabase* midori_database_statement_get_database (MidoriDatabaseStatement* self);
sqlite3* midori_database_get_db (MidoriDatabase* self);
const gchar* midori_database_statement_get_query (MidoriDatabaseStatement* self);
void midori_database_statement_bind (MidoriDatabaseStatement* self,
                                     const gchar* pname,
                                     GError** error,
                                     ...);
sqlite3_stmt* midori_database_statement_get_stmt (MidoriDatabaseStatement* self);
gboolean midori_database_statement_exec (MidoriDatabaseStatement* self,
                                         GError** error);
gboolean midori_database_statement_step (MidoriDatabaseStatement* self,
                                         GError** error);
gint64 midori_database_statement_row_id (MidoriDatabaseStatement* self,
                                         GError** error);
static gint midori_database_statement_column_index (MidoriDatabaseStatement* self,
                                             const gchar* name,
                                             GError** error);
gchar* midori_database_statement_get_string (MidoriDatabaseStatement* self,
                                             const gchar* name,
                                             GError** error);
gint64 midori_database_statement_get_int64 (MidoriDatabaseStatement* self,
                                            const gchar* name,
                                            GError** error);
gdouble midori_database_statement_get_double (MidoriDatabaseStatement* self,
                                              const gchar* name,
                                              GError** error);
void midori_database_statement_set_database (MidoriDatabaseStatement* self,
                                             MidoriDatabase* value);
void midori_database_statement_set_query (MidoriDatabaseStatement* self,
                                          const gchar* value);
static void midori_database_statement_finalize (GObject * obj);
static void _vala_midori_database_statement_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_midori_database_statement_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
#define MIDORI_DATABASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MIDORI_TYPE_DATABASE, MidoriDatabasePrivate))
MidoriDatabase* midori_database_new (const gchar* path,
                                     GError** error);
MidoriDatabase* midori_database_construct (GType object_type,
                                           const gchar* path,
                                           GError** error);
gboolean midori_database_init (MidoriDatabase* self,
                               GCancellable* cancellable,
                               GError** error);
static gchar* midori_database_resolve_path (MidoriDatabase* self,
                                     const gchar* path);
gchar* midori_paths_get_config_filename_for_writing (const gchar* filename);
static gboolean midori_database_real_init (MidoriDatabase* self,
                                    GCancellable* cancellable,
                                    GError** error);
const gchar* midori_database_get_path (MidoriDatabase* self);
gboolean midori_database_exists (MidoriDatabase* self,
                                 const gchar* path);
static void ___lambda5_ (MidoriDatabase* self,
                  const gchar* sql,
                  guint64 nanoseconds);
static void ____lambda5__sqlite_profile_callback (gpointer self,
                                           const gchar* sql,
                                           guint64 time);
gboolean midori_database_exec_script (MidoriDatabase* self,
                                      const gchar* filename,
                                      GError** error);
gboolean midori_database_exec (MidoriDatabase* self,
                               const gchar* query,
                               GError** error);
void midori_database_set_first_use (MidoriDatabase* self,
                                    gboolean value);
gboolean midori_database_attach (MidoriDatabase* self,
                                 const gchar* path,
                                 const gchar* alias,
                                 GError** error);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
gchar* midori_paths_get_res_filename (const gchar* filename);
gboolean midori_database_transaction (MidoriDatabase* self,
                                      MidoriDatabaseCallback callback,
                                      gpointer callback_target,
                                      GError** error);
static gboolean __lambda6_ (Block3Data* _data3_,
                     GError** error);
static gboolean ___lambda6__midori_database_callback (gpointer self,
                                               GError** error);
MidoriDatabaseStatement* midori_database_prepare (MidoriDatabase* self,
                                                  const gchar* query,
                                                  GError** error,
                                                  ...);
void midori_database_set_path (MidoriDatabase* self,
                               const gchar* value);
gboolean midori_database_get_first_use (MidoriDatabase* self);
static void midori_database_finalize (GObject * obj);
static void _vala_midori_database_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_midori_database_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GQuark
midori_database_error_quark (void)
{
	return g_quark_from_static_string ("midori_database_error-quark");
}


MidoriDatabaseStatement*
midori_database_statement_construct (GType object_type,
                                     MidoriDatabase* database,
                                     const gchar* query,
                                     GError** error)
{
	MidoriDatabaseStatement * self = NULL;
	GError * _inner_error_ = NULL;
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (database != NULL, NULL);
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 41 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self = (MidoriDatabaseStatement*) g_object_new (object_type, "database", database, "query", query, NULL);
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_statement_init (self, NULL, &_inner_error_);
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_object_unref0 (self);
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 291 "midori-database.c"
		} else {
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 42 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 299 "midori-database.c"
		}
	}
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return self;
#line 304 "midori-database.c"
}


MidoriDatabaseStatement*
midori_database_statement_new (MidoriDatabase* database,
                               const gchar* query,
                               GError** error)
{
#line 40 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return midori_database_statement_construct (MIDORI_TYPE_DATABASE_STATEMENT, database, query, error);
#line 315 "midori-database.c"
}


static gboolean
midori_database_statement_real_init (MidoriDatabaseStatement* self,
                                     GCancellable* cancellable,
                                     GError** error)
{
	gboolean result = FALSE;
	gint _result_ = 0;
	MidoriDatabase* _tmp0_;
	sqlite3* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	GError * _inner_error_ = NULL;
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->priv->_database;
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = midori_database_get_db (_tmp0_);
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp2_ = _tmp1_;
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp3_ = self->priv->_query;
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp2_, _tmp3_, -1, &_tmp4_, NULL);
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_sqlite3_finalize0 (self->_stmt);
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->_stmt = _tmp4_;
#line 46 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_result_ = _tmp5_;
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp6_ = _result_;
#line 47 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp6_ != SQLITE_OK) {
#line 354 "midori-database.c"
		MidoriDatabase* _tmp7_;
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GError* _tmp13_;
		GError* _tmp14_;
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp7_ = self->priv->_database;
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp8_ = midori_database_get_db (_tmp7_);
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp9_ = _tmp8_;
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp11_ = g_strdup_printf ("Failed to compile statement: %s", _tmp10_);
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp12_ = _tmp11_;
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp13_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_COMPILE, _tmp12_);
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp14_ = _tmp13_;
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp12_);
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp14_;
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 385 "midori-database.c"
			gboolean _tmp15_ = FALSE;
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp15_;
#line 391 "midori-database.c"
		} else {
			gboolean _tmp16_ = FALSE;
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 48 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp16_;
#line 400 "midori-database.c"
		}
	}
#line 49 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = TRUE;
#line 49 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 407 "midori-database.c"
}


gboolean
midori_database_statement_init (MidoriDatabaseStatement* self,
                                GCancellable* cancellable,
                                GError** error)
{
#line 45 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return MIDORI_DATABASE_STATEMENT_GET_CLASS (self)->init (self, cancellable, error);
#line 420 "midori-database.c"
}


static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 452 "midori-database.c"
}


void
midori_database_statement_bind (MidoriDatabaseStatement* self,
                                const gchar* pname,
                                GError** error,
                                ...)
{
	gint pindex = 0;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	va_list args = {0};
	GType ptype = 0UL;
	GType _tmp7_;
	GError * _inner_error_ = NULL;
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_if_fail (pname != NULL);
#line 59 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = midori_database_statement_get_stmt (self);
#line 59 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = _tmp0_;
#line 59 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	pindex = sqlite3_bind_parameter_index (_tmp1_, pname);
#line 60 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (pindex <= 0) {
#line 481 "midori-database.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp2_ = self->priv->_query;
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp3_ = g_strdup_printf ("No such parameter '%s' in statement: %s", pname, _tmp2_);
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp4_ = _tmp3_;
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp4_);
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp6_ = _tmp5_;
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp4_);
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp6_;
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return;
#line 507 "midori-database.c"
		} else {
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 61 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return;
#line 515 "midori-database.c"
		}
	}
#line 62 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	va_start (args, error);
#line 63 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	ptype = va_arg (args, GType);
#line 64 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp7_ = ptype;
#line 64 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp7_ == G_TYPE_STRING) {
#line 526 "midori-database.c"
		gchar* text = NULL;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		sqlite3_stmt* _tmp10_;
		sqlite3_stmt* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		GDestroyNotify _tmp14_;
		MidoriDatabase* _tmp15_;
		gboolean _tmp16_;
#line 65 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp8_ = va_arg (args, gchar*);
#line 65 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 65 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		text = _tmp9_;
#line 66 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp10_ = midori_database_statement_get_stmt (self);
#line 66 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp11_ = _tmp10_;
#line 66 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp12_ = text;
#line 66 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 66 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp14_ = g_free;
#line 66 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		sqlite3_bind_text (_tmp11_, pindex, _tmp13_, -1, _tmp14_);
#line 67 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp15_ = self->priv->_database;
#line 67 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp16_ = _tmp15_->trace;
#line 67 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_tmp16_) {
#line 561 "midori-database.c"
			FILE* _tmp17_;
			const gchar* _tmp18_;
#line 68 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp17_ = stdout;
#line 68 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp18_ = text;
#line 68 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			fprintf (_tmp17_, "%s=%s ", pname, _tmp18_);
#line 570 "midori-database.c"
		}
#line 64 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (text);
#line 574 "midori-database.c"
	} else {
		GType _tmp19_;
#line 69 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp19_ = ptype;
#line 69 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_tmp19_ == G_TYPE_INT64) {
#line 581 "midori-database.c"
			gint64 integer = 0LL;
			sqlite3_stmt* _tmp20_;
			sqlite3_stmt* _tmp21_;
			gint64 _tmp22_;
			MidoriDatabase* _tmp23_;
			gboolean _tmp24_;
#line 70 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			integer = va_arg (args, gint64);
#line 71 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp20_ = midori_database_statement_get_stmt (self);
#line 71 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp21_ = _tmp20_;
#line 71 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp22_ = integer;
#line 71 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			sqlite3_bind_int64 (_tmp21_, pindex, _tmp22_);
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp23_ = self->priv->_database;
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp24_ = _tmp23_->trace;
#line 72 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (_tmp24_) {
#line 604 "midori-database.c"
				FILE* _tmp25_;
				gint64 _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
#line 73 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp25_ = stdout;
#line 73 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp26_ = integer;
#line 73 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp27_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp26_);
#line 73 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp28_ = _tmp27_;
#line 73 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				fprintf (_tmp25_, "%s=%s ", pname, _tmp28_);
#line 73 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (_tmp28_);
#line 621 "midori-database.c"
			}
		} else {
			GType _tmp29_;
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp29_ = ptype;
#line 74 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (_tmp29_ == G_TYPE_DOUBLE) {
#line 629 "midori-database.c"
				gdouble stuntman = 0.0;
				sqlite3_stmt* _tmp30_;
				sqlite3_stmt* _tmp31_;
				gdouble _tmp32_;
				MidoriDatabase* _tmp33_;
				gboolean _tmp34_;
#line 75 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				stuntman = va_arg (args, gdouble);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp30_ = midori_database_statement_get_stmt (self);
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp31_ = _tmp30_;
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp32_ = stuntman;
#line 76 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				sqlite3_bind_double (_tmp31_, pindex, _tmp32_);
#line 77 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp33_ = self->priv->_database;
#line 77 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp34_ = _tmp33_->trace;
#line 77 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				if (_tmp34_) {
#line 652 "midori-database.c"
					FILE* _tmp35_;
					gdouble _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
#line 78 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp35_ = stdout;
#line 78 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp36_ = stuntman;
#line 78 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp37_ = double_to_string (_tmp36_);
#line 78 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp38_ = _tmp37_;
#line 78 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					fprintf (_tmp35_, "%s=%s ", pname, _tmp38_);
#line 78 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_g_free0 (_tmp38_);
#line 669 "midori-database.c"
				}
			} else {
				GType _tmp39_;
				const gchar* _tmp40_;
				const gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				GError* _tmp44_;
				GError* _tmp45_;
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp39_ = ptype;
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp40_ = g_type_name (_tmp39_);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp41_ = self->priv->_query;
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp42_ = g_strdup_printf ("Invalid type '%s' for '%s' in statement: %s", _tmp40_, pname, _tmp41_);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp43_ = _tmp42_;
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp44_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp43_);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp45_ = _tmp44_;
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (_tmp43_);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_inner_error_ = _tmp45_;
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					g_propagate_error (error, _inner_error_);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					va_end (args);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					return;
#line 705 "midori-database.c"
				} else {
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					va_end (args);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					g_clear_error (&_inner_error_);
#line 80 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					return;
#line 715 "midori-database.c"
				}
			}
		}
	}
#line 58 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	va_end (args);
#line 722 "midori-database.c"
}


gboolean
midori_database_statement_exec (MidoriDatabaseStatement* self,
                                GError** error)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
#line 86 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = midori_database_statement_step (self, &_inner_error_);
#line 87 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 87 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 741 "midori-database.c"
			gboolean _tmp1_ = FALSE;
#line 87 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 87 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp1_;
#line 747 "midori-database.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 87 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 87 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 87 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp2_;
#line 756 "midori-database.c"
		}
	}
#line 87 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp0_) {
#line 761 "midori-database.c"
		GError* _tmp3_;
#line 88 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp3_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, "More rows available - use step instead of exec");
#line 88 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp3_;
#line 88 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 769 "midori-database.c"
			gboolean _tmp4_ = FALSE;
#line 88 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 88 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp4_;
#line 775 "midori-database.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 88 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 88 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 88 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp5_;
#line 784 "midori-database.c"
		}
	}
#line 89 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = TRUE;
#line 89 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 791 "midori-database.c"
}


gboolean
midori_database_statement_step (MidoriDatabaseStatement* self,
                                GError** error)
{
	gboolean result = FALSE;
	gint _result_ = 0;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	MidoriDatabase* _tmp12_;
	sqlite3* _tmp13_;
	sqlite3* _tmp14_;
	gint _tmp15_;
	GError * _inner_error_ = NULL;
#line 95 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = midori_database_statement_get_stmt (self);
#line 96 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = _tmp0_;
#line 96 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_result_ = sqlite3_step (_tmp1_);
#line 97 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp3_ = _result_;
#line 97 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp3_ != SQLITE_DONE) {
#line 822 "midori-database.c"
		gint _tmp4_;
#line 97 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp4_ = _result_;
#line 97 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp2_ = _tmp4_ != SQLITE_ROW;
#line 828 "midori-database.c"
	} else {
#line 97 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp2_ = FALSE;
#line 832 "midori-database.c"
	}
#line 97 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp2_) {
#line 836 "midori-database.c"
		MidoriDatabase* _tmp5_;
		sqlite3* _tmp6_;
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = self->priv->_database;
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp6_ = midori_database_get_db (_tmp5_);
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp7_ = _tmp6_;
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp9_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp8_);
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp9_;
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 856 "midori-database.c"
			gboolean _tmp10_ = FALSE;
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp10_;
#line 862 "midori-database.c"
		} else {
			gboolean _tmp11_ = FALSE;
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 98 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp11_;
#line 871 "midori-database.c"
		}
	}
#line 99 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp12_ = self->priv->_database;
#line 99 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp13_ = midori_database_get_db (_tmp12_);
#line 99 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp14_ = _tmp13_;
#line 99 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->priv->last_row_id = sqlite3_last_insert_rowid (_tmp14_);
#line 100 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp15_ = _result_;
#line 100 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp15_ == SQLITE_ROW;
#line 100 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 888 "midori-database.c"
}


gint64
midori_database_statement_row_id (MidoriDatabaseStatement* self,
                                  GError** error)
{
	gint64 result = 0LL;
	gint64 _tmp0_;
	gint64 _tmp4_;
	GError * _inner_error_ = NULL;
#line 108 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 109 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->priv->last_row_id;
#line 109 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp0_ == ((gint64) -1)) {
#line 906 "midori-database.c"
		GError* _tmp1_;
#line 110 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp1_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, "No row id");
#line 110 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp1_;
#line 110 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 914 "midori-database.c"
			gint64 _tmp2_ = 0LL;
#line 110 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 110 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp2_;
#line 920 "midori-database.c"
		} else {
			gint64 _tmp3_ = 0LL;
#line 110 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp3_;
#line 929 "midori-database.c"
		}
	}
#line 111 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp4_ = self->priv->last_row_id;
#line 111 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp4_;
#line 111 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 938 "midori-database.c"
}


static gint
midori_database_statement_column_index (MidoriDatabaseStatement* self,
                                        const gchar* name,
                                        GError** error)
{
	gint result = 0;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GError* _tmp12_;
	GError* _tmp13_;
	GError * _inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 114 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 958 "midori-database.c"
	{
		gint i = 0;
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		i = 0;
#line 963 "midori-database.c"
		{
			gboolean _tmp0_ = FALSE;
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp0_ = TRUE;
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			while (TRUE) {
#line 970 "midori-database.c"
				gint _tmp2_;
				sqlite3_stmt* _tmp3_;
				sqlite3_stmt* _tmp4_;
				sqlite3_stmt* _tmp5_;
				sqlite3_stmt* _tmp6_;
				gint _tmp7_;
				const gchar* _tmp8_;
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				if (!_tmp0_) {
#line 980 "midori-database.c"
					gint _tmp1_;
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp1_ = i;
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					i = _tmp1_ + 1;
#line 986 "midori-database.c"
				}
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp0_ = FALSE;
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp2_ = i;
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp3_ = midori_database_statement_get_stmt (self);
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp4_ = _tmp3_;
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				if (!(_tmp2_ < sqlite3_column_count (_tmp4_))) {
#line 115 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					break;
#line 1000 "midori-database.c"
				}
#line 116 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp5_ = midori_database_statement_get_stmt (self);
#line 116 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp6_ = _tmp5_;
#line 116 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp7_ = i;
#line 116 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp8_ = sqlite3_column_name (_tmp6_, _tmp7_);
#line 116 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				if (g_strcmp0 (name, _tmp8_) == 0) {
#line 117 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					result = i;
#line 117 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					return result;
#line 1016 "midori-database.c"
				}
			}
		}
	}
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp9_ = self->priv->_query;
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp10_ = g_strdup_printf ("No such column '%s' in row: %s", name, _tmp9_);
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp11_ = _tmp10_;
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp12_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp11_);
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp13_ = _tmp12_;
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (_tmp11_);
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_inner_error_ = _tmp13_;
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 1037 "midori-database.c"
		gint _tmp14_ = 0;
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_propagate_error (error, _inner_error_);
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		return _tmp14_;
#line 1043 "midori-database.c"
	} else {
		gint _tmp15_ = 0;
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_clear_error (&_inner_error_);
#line 119 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		return _tmp15_;
#line 1052 "midori-database.c"
	}
}


gchar*
midori_database_statement_get_string (MidoriDatabaseStatement* self,
                                      const gchar* name,
                                      GError** error)
{
	gchar* result = NULL;
	gint index = 0;
	gint type = 0;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp14_;
	gint _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	GError * _inner_error_ = NULL;
#line 126 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 127 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	index = midori_database_statement_column_index (self, name, &_inner_error_);
#line 127 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 127 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 127 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 127 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 1092 "midori-database.c"
		} else {
#line 127 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 127 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 127 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 1100 "midori-database.c"
		}
	}
#line 128 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = midori_database_statement_get_stmt (self);
#line 128 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = _tmp0_;
#line 128 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp2_ = index;
#line 128 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	type = sqlite3_column_type (_tmp1_, _tmp2_);
#line 129 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp4_ = midori_database_statement_get_stmt (self);
#line 129 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp5_ = _tmp4_;
#line 129 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp6_ = index;
#line 129 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (sqlite3_column_type (_tmp5_, _tmp6_) != SQLITE3_TEXT) {
#line 1119 "midori-database.c"
		gint _tmp7_;
#line 129 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp7_ = type;
#line 129 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp3_ = _tmp7_ != SQLITE_NULL;
#line 1125 "midori-database.c"
	} else {
#line 129 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp3_ = FALSE;
#line 1129 "midori-database.c"
	}
#line 129 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp3_) {
#line 1133 "midori-database.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GError* _tmp11_;
		GError* _tmp12_;
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp8_ = self->priv->_query;
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp9_ = g_strdup_printf ("Getting '%s' with wrong type in row: %s", name, _tmp8_);
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp10_ = _tmp9_;
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp11_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp10_);
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp12_ = _tmp11_;
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp10_);
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp12_;
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 1159 "midori-database.c"
		} else {
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 130 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 1167 "midori-database.c"
		}
	}
#line 131 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp13_ = midori_database_statement_get_stmt (self);
#line 131 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp14_ = _tmp13_;
#line 131 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp15_ = index;
#line 131 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp16_ = sqlite3_column_text (_tmp14_, _tmp15_);
#line 131 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 131 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp17_;
#line 131 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 1184 "midori-database.c"
}


gint64
midori_database_statement_get_int64 (MidoriDatabaseStatement* self,
                                     const gchar* name,
                                     GError** error)
{
	gint64 result = 0LL;
	gint index = 0;
	gint type = 0;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	sqlite3_stmt* _tmp20_;
	sqlite3_stmt* _tmp21_;
	gint _tmp22_;
	GError * _inner_error_ = NULL;
#line 138 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 138 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (name != NULL, 0LL);
#line 139 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	index = midori_database_statement_column_index (self, name, &_inner_error_);
#line 139 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 139 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 1215 "midori-database.c"
			gint64 _tmp0_ = 0LL;
#line 139 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 139 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp0_;
#line 1221 "midori-database.c"
		} else {
			gint64 _tmp1_ = 0LL;
#line 139 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 139 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 139 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp1_;
#line 1230 "midori-database.c"
		}
	}
#line 140 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp2_ = midori_database_statement_get_stmt (self);
#line 140 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp3_ = _tmp2_;
#line 140 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp4_ = index;
#line 140 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	type = sqlite3_column_type (_tmp3_, _tmp4_);
#line 141 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp6_ = type;
#line 141 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp6_ != SQLITE_INTEGER) {
#line 1245 "midori-database.c"
		gint _tmp7_;
#line 141 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp7_ = type;
#line 141 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = _tmp7_ != SQLITE_NULL;
#line 1251 "midori-database.c"
	} else {
#line 141 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = FALSE;
#line 1255 "midori-database.c"
	}
#line 141 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp5_) {
#line 1259 "midori-database.c"
		sqlite3_stmt* _tmp8_;
		sqlite3_stmt* _tmp9_;
		gint _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		GError* _tmp17_;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp8_ = midori_database_statement_get_stmt (self);
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp9_ = _tmp8_;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp10_ = index;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp11_ = sqlite3_column_text (_tmp9_, _tmp10_);
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp12_ = type;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp13_ = self->priv->_query;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp14_ = g_strdup_printf ("Getting '%s' with value '%s' of wrong type %d in row: %s", name, _tmp11_, _tmp12_, _tmp13_);
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp15_ = _tmp14_;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp16_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp15_);
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp17_ = _tmp16_;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp15_);
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp17_;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 1296 "midori-database.c"
			gint64 _tmp18_ = 0LL;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp18_;
#line 1302 "midori-database.c"
		} else {
			gint64 _tmp19_ = 0LL;
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 142 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp19_;
#line 1311 "midori-database.c"
		}
	}
#line 144 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp20_ = midori_database_statement_get_stmt (self);
#line 144 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp21_ = _tmp20_;
#line 144 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp22_ = index;
#line 144 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = sqlite3_column_int64 (_tmp21_, _tmp22_);
#line 144 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 1324 "midori-database.c"
}


gdouble
midori_database_statement_get_double (MidoriDatabaseStatement* self,
                                      const gchar* name,
                                      GError** error)
{
	gdouble result = 0.0;
	gint index = 0;
	gint type = 0;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	gdouble _tmp15_ = 0.0;
	gint _tmp16_;
	GError * _inner_error_ = NULL;
#line 151 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 151 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (name != NULL, 0.0);
#line 152 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	index = midori_database_statement_column_index (self, name, &_inner_error_);
#line 152 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 152 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 1354 "midori-database.c"
			gdouble _tmp0_ = 0.0;
#line 152 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 152 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp0_;
#line 1360 "midori-database.c"
		} else {
			gdouble _tmp1_ = 0.0;
#line 152 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 152 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 152 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp1_;
#line 1369 "midori-database.c"
		}
	}
#line 153 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp2_ = midori_database_statement_get_stmt (self);
#line 153 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp3_ = _tmp2_;
#line 153 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp4_ = index;
#line 153 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	type = sqlite3_column_type (_tmp3_, _tmp4_);
#line 154 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp6_ = type;
#line 154 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp6_ != SQLITE_FLOAT) {
#line 1384 "midori-database.c"
		gint _tmp7_;
#line 154 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp7_ = type;
#line 154 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = _tmp7_ != SQLITE_NULL;
#line 1390 "midori-database.c"
	} else {
#line 154 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = FALSE;
#line 1394 "midori-database.c"
	}
#line 154 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp5_) {
#line 1398 "midori-database.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GError* _tmp11_;
		GError* _tmp12_;
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp8_ = self->priv->_query;
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp9_ = g_strdup_printf ("Getting '%s' with wrong type in row: %s", name, _tmp8_);
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp10_ = _tmp9_;
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp11_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp10_);
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp12_ = _tmp11_;
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp10_);
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp12_;
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 1420 "midori-database.c"
			gdouble _tmp13_ = 0.0;
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp13_;
#line 1426 "midori-database.c"
		} else {
			gdouble _tmp14_ = 0.0;
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 155 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp14_;
#line 1435 "midori-database.c"
		}
	}
#line 156 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp16_ = type;
#line 156 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp16_ == SQLITE_NULL) {
#line 156 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp15_ = ((double) NAN);
#line 1444 "midori-database.c"
	} else {
		sqlite3_stmt* _tmp17_;
		sqlite3_stmt* _tmp18_;
		gint _tmp19_;
#line 156 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp17_ = midori_database_statement_get_stmt (self);
#line 156 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp18_ = _tmp17_;
#line 156 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp19_ = index;
#line 156 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp15_ = sqlite3_column_double (_tmp18_, _tmp19_);
#line 1457 "midori-database.c"
	}
#line 156 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp15_;
#line 156 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 1463 "midori-database.c"
}


sqlite3_stmt*
midori_database_statement_get_stmt (MidoriDatabaseStatement* self)
{
	sqlite3_stmt* result;
	sqlite3_stmt* _tmp0_;
#line 34 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->_stmt;
#line 34 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 1480 "midori-database.c"
}


MidoriDatabase*
midori_database_statement_get_database (MidoriDatabaseStatement* self)
{
	MidoriDatabase* result;
	MidoriDatabase* _tmp0_;
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->priv->_database;
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 1497 "midori-database.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return self ? g_object_ref (self) : NULL;
#line 1506 "midori-database.c"
}


void
midori_database_statement_set_database (MidoriDatabaseStatement* self,
                                        MidoriDatabase* value)
{
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (midori_database_statement_get_database (self) != value) {
#line 1518 "midori-database.c"
		MidoriDatabase* _tmp0_;
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_object_unref0 (self->priv->_database);
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		self->priv->_database = _tmp0_;
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_object_notify_by_pspec ((GObject *) self, midori_database_statement_properties[MIDORI_DATABASE_STATEMENT_DATABASE_PROPERTY]);
#line 1528 "midori-database.c"
	}
}


const gchar*
midori_database_statement_get_query (MidoriDatabaseStatement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->priv->_query;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 1546 "midori-database.c"
}


void
midori_database_statement_set_query (MidoriDatabaseStatement* self,
                                     const gchar* value)
{
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (g_strcmp0 (value, midori_database_statement_get_query (self)) != 0) {
#line 1558 "midori-database.c"
		gchar* _tmp0_;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp0_ = g_strdup (value);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (self->priv->_query);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		self->priv->_query = _tmp0_;
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_object_notify_by_pspec ((GObject *) self, midori_database_statement_properties[MIDORI_DATABASE_STATEMENT_QUERY_PROPERTY]);
#line 1568 "midori-database.c"
	}
}


static void
midori_database_statement_class_init (MidoriDatabaseStatementClass * klass)
{
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_statement_parent_class = g_type_class_peek_parent (klass);
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_type_class_add_private (klass, sizeof (MidoriDatabaseStatementPrivate));
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	((MidoriDatabaseStatementClass *) klass)->init = (gboolean (*) (MidoriDatabaseStatement *, GCancellable*, GError**)) midori_database_statement_real_init;
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_midori_database_statement_get_property;
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_midori_database_statement_set_property;
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->finalize = midori_database_statement_finalize;
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_STATEMENT_STMT_PROPERTY, midori_database_statement_properties[MIDORI_DATABASE_STATEMENT_STMT_PROPERTY] = g_param_spec_pointer ("stmt", "stmt", "stmt", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_STATEMENT_DATABASE_PROPERTY, midori_database_statement_properties[MIDORI_DATABASE_STATEMENT_DATABASE_PROPERTY] = g_param_spec_object ("database", "database", "database", MIDORI_TYPE_DATABASE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_STATEMENT_QUERY_PROPERTY, midori_database_statement_properties[MIDORI_DATABASE_STATEMENT_QUERY_PROPERTY] = g_param_spec_string ("query", "query", "query", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1594 "midori-database.c"
}


static void
midori_database_statement_g_initable_interface_init (GInitableIface * iface)
{
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_statement_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	iface->init = (gboolean (*) (GInitable *, GCancellable*, GError**)) midori_database_statement_init;
#line 1605 "midori-database.c"
}


static void
midori_database_statement_instance_init (MidoriDatabaseStatement * self)
{
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->priv = MIDORI_DATABASE_STATEMENT_GET_PRIVATE (self);
#line 35 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->_stmt = NULL;
#line 38 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->priv->last_row_id = (gint64) -1;
#line 1618 "midori-database.c"
}


static void
midori_database_statement_finalize (GObject * obj)
{
	MidoriDatabaseStatement * self;
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatement);
#line 35 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_sqlite3_finalize0 (self->_stmt);
#line 36 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_object_unref0 (self->priv->_database);
#line 37 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (self->priv->_query);
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	G_OBJECT_CLASS (midori_database_statement_parent_class)->finalize (obj);
#line 1636 "midori-database.c"
}


GType
midori_database_statement_get_type (void)
{
	static volatile gsize midori_database_statement_type_id__volatile = 0;
	if (g_once_init_enter (&midori_database_statement_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MidoriDatabaseStatementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) midori_database_statement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MidoriDatabaseStatement), 0, (GInstanceInitFunc) midori_database_statement_instance_init, NULL };
		static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) midori_database_statement_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType midori_database_statement_type_id;
		midori_database_statement_type_id = g_type_register_static (G_TYPE_OBJECT, "MidoriDatabaseStatement", &g_define_type_info, 0);
		g_type_add_interface_static (midori_database_statement_type_id, g_initable_get_type (), &g_initable_info);
		g_once_init_leave (&midori_database_statement_type_id__volatile, midori_database_statement_type_id);
	}
	return midori_database_statement_type_id__volatile;
}


static void
_vala_midori_database_statement_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	MidoriDatabaseStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatement);
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_STMT_PROPERTY:
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_value_set_pointer (value, midori_database_statement_get_stmt (self));
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_DATABASE_PROPERTY:
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_value_set_object (value, midori_database_statement_get_database (self));
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_QUERY_PROPERTY:
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_value_set_string (value, midori_database_statement_get_query (self));
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 1684 "midori-database.c"
		default:
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 1690 "midori-database.c"
	}
}


static void
_vala_midori_database_statement_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	MidoriDatabaseStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatement);
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_DATABASE_PROPERTY:
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		midori_database_statement_set_database (self, g_value_get_object (value));
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_QUERY_PROPERTY:
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		midori_database_statement_set_query (self, g_value_get_string (value));
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 1717 "midori-database.c"
		default:
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 1723 "midori-database.c"
	}
}


MidoriDatabase*
midori_database_construct (GType object_type,
                           const gchar* path,
                           GError** error)
{
	MidoriDatabase * self = NULL;
	GError * _inner_error_ = NULL;
#line 179 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 180 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self = (MidoriDatabase*) g_object_new (object_type, "path", path, NULL);
#line 181 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_init (self, NULL, &_inner_error_);
#line 181 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 181 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 181 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 181 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_object_unref0 (self);
#line 181 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 1751 "midori-database.c"
		} else {
#line 181 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 181 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 181 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 1759 "midori-database.c"
		}
	}
#line 179 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return self;
#line 1764 "midori-database.c"
}


MidoriDatabase*
midori_database_new (const gchar* path,
                     GError** error)
{
#line 179 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return midori_database_construct (MIDORI_TYPE_DATABASE, path, error);
#line 1774 "midori-database.c"
}


static gchar*
midori_database_resolve_path (MidoriDatabase* self,
                              const gchar* path)
{
	gchar* result = NULL;
	gchar* _tmp2_;
#line 184 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 184 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 185 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (g_str_has_prefix (path, ":memory:")) {
#line 1790 "midori-database.c"
		gchar* _tmp0_;
#line 186 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp0_ = g_strdup (":memory:");
#line 186 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		result = _tmp0_;
#line 186 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		return result;
#line 1798 "midori-database.c"
	} else {
#line 187 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (!g_path_is_absolute (path)) {
#line 1802 "midori-database.c"
			gchar* _tmp1_;
#line 188 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp1_ = midori_paths_get_config_filename_for_writing (path);
#line 188 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			result = _tmp1_;
#line 188 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return result;
#line 1810 "midori-database.c"
		}
	}
#line 189 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp2_ = g_strdup (path);
#line 189 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp2_;
#line 189 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 1819 "midori-database.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 1839 "midori-database.c"
}


static void
___lambda5_ (MidoriDatabase* self,
             const gchar* sql,
             guint64 nanoseconds)
{
	gchar* milliseconds = NULL;
	gchar* _tmp0_;
	FILE* _tmp1_;
	const gchar* _tmp2_;
#line 205 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_if_fail (sql != NULL);
#line 207 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = g_strdup_printf ("%" G_GUINT64_FORMAT, nanoseconds / 1000000);
#line 207 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	milliseconds = _tmp0_;
#line 208 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = stdout;
#line 208 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp2_ = self->priv->_path;
#line 208 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	fprintf (_tmp1_, "§§ %s: %s (%sms)\n", _tmp2_, sql, milliseconds);
#line 205 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (milliseconds);
#line 1866 "midori-database.c"
}


static void
____lambda5__sqlite_profile_callback (gpointer self,
                                      const gchar* sql,
                                      guint64 time)
{
#line 205 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	___lambda5_ ((MidoriDatabase*) self, sql, time);
#line 1877 "midori-database.c"
}


static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar* * errmsg)
{
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
#line 34 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	ec = _tmp1_;
#line 37 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 1907 "midori-database.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 1918 "midori-database.c"
	}
#line 40 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 40 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	result = ec;
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	if (errmsg) {
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 1930 "midori-database.c"
	} else {
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 1934 "midori-database.c"
	}
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	return result;
#line 1938 "midori-database.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 239 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return self ? g_error_copy (self) : NULL;
#line 1947 "midori-database.c"
}


static gboolean
midori_database_real_init (MidoriDatabase* self,
                           GCancellable* cancellable,
                           GError** error)
{
	gboolean result = FALSE;
	gchar* real_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean exists = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	sqlite3* _tmp4_ = NULL;
	gint _tmp5_;
	const gchar* _tmp13_ = NULL;
	const gchar* _tmp14_;
	gchar* token = NULL;
	gchar* _tmp15_;
	gchar* basename = NULL;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** parts = NULL;
	const gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint parts_length1;
	gint _parts_size_;
	const gchar* _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gboolean _tmp26_;
	sqlite3* _tmp31_;
	sqlite3* _tmp32_;
	gint _tmp33_;
	sqlite3* _tmp36_;
	sqlite3* _tmp37_;
	const gchar* _tmp38_;
	gint64 user_version = 0LL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp39_;
	sqlite3* _tmp40_;
	sqlite3_stmt* _tmp41_ = NULL;
	gint _tmp42_;
	sqlite3_stmt* _tmp52_;
	sqlite3_stmt* _tmp62_;
	gint64 _tmp63_;
	gboolean _tmp92_;
	GError * _inner_error_ = NULL;
#line 193 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->priv->_path;
#line 193 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = midori_database_resolve_path (self, _tmp0_);
#line 193 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	real_path = _tmp1_;
#line 194 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp2_ = real_path;
#line 194 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	exists = midori_database_exists (self, _tmp2_);
#line 196 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp3_ = real_path;
#line 196 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp5_ = sqlite3_open_v2 (_tmp3_, &_tmp4_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 196 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_sqlite3_close0 (self->_db);
#line 196 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->_db = _tmp4_;
#line 196 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp5_ != SQLITE_OK) {
#line 2022 "midori-database.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp6_ = real_path;
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp7_ = g_strdup_printf ("Failed to open database %s", _tmp6_);
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp8_ = _tmp7_;
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp9_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_OPEN, _tmp8_);
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp10_ = _tmp9_;
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp8_);
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp10_;
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2044 "midori-database.c"
			gboolean _tmp11_ = FALSE;
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp11_;
#line 2052 "midori-database.c"
		} else {
			gboolean _tmp12_ = FALSE;
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 197 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp12_;
#line 2063 "midori-database.c"
		}
	}
#line 199 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp14_ = g_getenv ("MIDORI_DEBUG");
#line 199 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp13_ = _tmp14_;
#line 199 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp13_ == NULL) {
#line 199 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp13_ = "";
#line 2074 "midori-database.c"
	}
#line 199 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp15_ = g_strdup (_tmp13_);
#line 199 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	token = _tmp15_;
#line 200 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp16_ = self->priv->_path;
#line 200 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp17_ = g_path_get_basename (_tmp16_);
#line 200 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	basename = _tmp17_;
#line 201 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp18_ = basename;
#line 201 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, ".", 0);
#line 201 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	parts = _tmp20_;
#line 201 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	parts_length1 = _vala_array_length (_tmp19_);
#line 201 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_parts_size_ = parts_length1;
#line 202 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp21_ = token;
#line 202 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp22_ = parts;
#line 202 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp22__length1 = parts_length1;
#line 202 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp23_ = _tmp22_[0];
#line 202 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp24_ = g_strconcat ("db:", _tmp23_, NULL);
#line 202 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp25_ = _tmp24_;
#line 202 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->trace = string_contains (_tmp21_, _tmp25_);
#line 202 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (_tmp25_);
#line 203 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp26_ = self->trace;
#line 203 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp26_) {
#line 2116 "midori-database.c"
		FILE* _tmp27_;
		const gchar* _tmp28_;
		sqlite3* _tmp29_;
		sqlite3* _tmp30_;
#line 204 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp27_ = stdout;
#line 204 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp28_ = self->priv->_path;
#line 204 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		fprintf (_tmp27_, "§§ Tracing %s\n", _tmp28_);
#line 205 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp29_ = midori_database_get_db (self);
#line 205 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp30_ = _tmp29_;
#line 205 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		sqlite3_profile (_tmp30_, ____lambda5__sqlite_profile_callback, self);
#line 2133 "midori-database.c"
	}
#line 212 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp31_ = midori_database_get_db (self);
#line 212 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp32_ = _tmp31_;
#line 212 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp33_ = _sqlite3_exec (_tmp32_, "PRAGMA journal_mode = WAL; PRAGMA cache_size = 32100;", NULL, NULL, NULL);
#line 212 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp33_ != SQLITE_OK) {
#line 2143 "midori-database.c"
		sqlite3* _tmp34_;
		sqlite3* _tmp35_;
#line 213 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp34_ = midori_database_get_db (self);
#line 213 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp35_ = _tmp34_;
#line 213 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_sqlite3_exec (_tmp35_, "PRAGMA synchronous = NORMAL; PRAGMA temp_store = MEMORY;", NULL, NULL, NULL);
#line 2152 "midori-database.c"
	}
#line 214 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp36_ = midori_database_get_db (self);
#line 214 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp37_ = _tmp36_;
#line 214 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_sqlite3_exec (_tmp37_, "PRAGMA count_changes = OFF;", NULL, NULL, NULL);
#line 216 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp38_ = real_path;
#line 216 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (g_strcmp0 (_tmp38_, ":memory:") == 0) {
#line 217 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		result = TRUE;
#line 217 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 217 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (basename);
#line 217 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (token);
#line 217 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (real_path);
#line 217 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		return result;
#line 2176 "midori-database.c"
	}
#line 221 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp39_ = midori_database_get_db (self);
#line 221 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp40_ = _tmp39_;
#line 221 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp42_ = sqlite3_prepare_v2 (_tmp40_, "PRAGMA user_version;", -1, &_tmp41_, NULL);
#line 221 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_sqlite3_finalize0 (stmt);
#line 221 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	stmt = _tmp41_;
#line 221 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp42_ != SQLITE_OK) {
#line 2190 "midori-database.c"
		sqlite3* _tmp43_;
		sqlite3* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		GError* _tmp48_;
		GError* _tmp49_;
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp43_ = midori_database_get_db (self);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp44_ = _tmp43_;
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp45_ = sqlite3_errmsg (_tmp44_);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp46_ = g_strdup_printf ("Failed to compile statement %s", _tmp45_);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp47_ = _tmp46_;
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp48_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp47_);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp49_ = _tmp48_;
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp47_);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp49_;
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2218 "midori-database.c"
			gboolean _tmp50_ = FALSE;
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_sqlite3_finalize0 (stmt);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (token);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp50_;
#line 2234 "midori-database.c"
		} else {
			gboolean _tmp51_ = FALSE;
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_sqlite3_finalize0 (stmt);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (token);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 222 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp51_;
#line 2253 "midori-database.c"
		}
	}
#line 223 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp52_ = stmt;
#line 223 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (sqlite3_step (_tmp52_) != SQLITE_ROW) {
#line 2260 "midori-database.c"
		sqlite3* _tmp53_;
		sqlite3* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		GError* _tmp58_;
		GError* _tmp59_;
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp53_ = midori_database_get_db (self);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp54_ = _tmp53_;
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp55_ = sqlite3_errmsg (_tmp54_);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp56_ = g_strdup_printf ("Failed to get row %s", _tmp55_);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp57_ = _tmp56_;
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp58_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp57_);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp59_ = _tmp58_;
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp57_);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp59_;
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2288 "midori-database.c"
			gboolean _tmp60_ = FALSE;
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_sqlite3_finalize0 (stmt);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (token);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp60_;
#line 2304 "midori-database.c"
		} else {
			gboolean _tmp61_ = FALSE;
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_sqlite3_finalize0 (stmt);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (token);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 224 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp61_;
#line 2323 "midori-database.c"
		}
	}
#line 225 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp62_ = stmt;
#line 225 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	user_version = sqlite3_column_int64 (_tmp62_, 0);
#line 227 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp63_ = user_version;
#line 227 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp63_ == ((gint64) 0)) {
#line 2334 "midori-database.c"
		gint64 _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		midori_database_exec_script (self, "Create", &_inner_error_);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2346 "midori-database.c"
				gboolean _tmp64_ = FALSE;
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_propagate_error (error, _inner_error_);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (basename);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (token);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (real_path);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				return _tmp64_;
#line 2362 "midori-database.c"
			} else {
				gboolean _tmp65_ = FALSE;
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (basename);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (token);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (real_path);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 228 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				return _tmp65_;
#line 2381 "midori-database.c"
			}
		}
#line 229 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		user_version = (gint64) 1;
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp66_ = user_version;
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp67_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp66_);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp68_ = _tmp67_;
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp69_ = g_strconcat ("PRAGMA user_version = ", _tmp68_, NULL);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp70_ = _tmp69_;
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		midori_database_exec (self, _tmp70_, &_inner_error_);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp70_);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp68_);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2406 "midori-database.c"
				gboolean _tmp71_ = FALSE;
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_propagate_error (error, _inner_error_);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (basename);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (token);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (real_path);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				return _tmp71_;
#line 2422 "midori-database.c"
			} else {
				gboolean _tmp72_ = FALSE;
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (basename);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (token);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (real_path);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 230 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				return _tmp72_;
#line 2441 "midori-database.c"
			}
		}
	}
#line 233 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	while (TRUE) {
#line 2447 "midori-database.c"
		gint64 _tmp84_;
		gint64 _tmp85_;
		gchar* _tmp86_;
		gchar* _tmp87_;
		gchar* _tmp88_;
		gchar* _tmp89_;
		{
			gint64 _tmp73_;
			gchar* _tmp74_;
			gchar* _tmp75_;
			gchar* _tmp76_;
			gchar* _tmp77_;
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp73_ = user_version;
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp74_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp73_);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp75_ = _tmp74_;
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp76_ = g_strconcat ("Update", _tmp75_, NULL);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp77_ = _tmp76_;
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			midori_database_exec_script (self, _tmp77_, &_inner_error_);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (_tmp77_);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (_tmp75_);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2478 "midori-database.c"
				gboolean _tmp78_ = FALSE;
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2482 "midori-database.c"
					goto __catch13_midori_database_error;
				}
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (basename);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (token);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (real_path);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 235 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				return _tmp78_;
#line 2501 "midori-database.c"
			}
		}
		goto __finally13;
		__catch13_midori_database_error:
		{
			GError* _error_ = NULL;
			GError* _tmp79_;
			GError* _tmp80_;
			GError* _tmp81_;
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_error_ = _inner_error_;
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_inner_error_ = NULL;
#line 237 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp79_ = _error_;
#line 237 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (g_error_matches (_tmp79_, MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_FILENAME)) {
#line 238 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_error_free0 (_error_);
#line 238 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				break;
#line 2523 "midori-database.c"
			}
#line 239 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp80_ = _error_;
#line 239 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp81_ = _g_error_copy0 (_tmp80_);
#line 239 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_inner_error_ = _tmp81_;
#line 239 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_error_free0 (_error_);
#line 2533 "midori-database.c"
			goto __finally13;
		}
		__finally13:
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2541 "midori-database.c"
				gboolean _tmp82_ = FALSE;
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_propagate_error (error, _inner_error_);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (basename);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (token);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (real_path);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				return _tmp82_;
#line 2557 "midori-database.c"
			} else {
				gboolean _tmp83_ = FALSE;
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (basename);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (token);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (real_path);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 234 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				return _tmp83_;
#line 2576 "midori-database.c"
			}
		}
#line 241 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp84_ = user_version;
#line 241 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		user_version = _tmp84_ + 1;
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp85_ = user_version;
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp86_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp85_);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp87_ = _tmp86_;
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp88_ = g_strconcat ("PRAGMA user_version = ", _tmp87_, NULL);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp89_ = _tmp88_;
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		midori_database_exec (self, _tmp89_, &_inner_error_);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp89_);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp87_);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2603 "midori-database.c"
				gboolean _tmp90_ = FALSE;
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_propagate_error (error, _inner_error_);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (basename);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (token);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (real_path);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				return _tmp90_;
#line 2619 "midori-database.c"
			} else {
				gboolean _tmp91_ = FALSE;
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (basename);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (token);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_g_free0 (real_path);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 242 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				return _tmp91_;
#line 2638 "midori-database.c"
			}
		}
	}
#line 245 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp92_ = exists;
#line 245 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_set_first_use (self, !_tmp92_);
#line 246 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = TRUE;
#line 246 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_sqlite3_finalize0 (stmt);
#line 246 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 246 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (basename);
#line 246 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (token);
#line 246 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (real_path);
#line 246 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 2660 "midori-database.c"
}


gboolean
midori_database_init (MidoriDatabase* self,
                      GCancellable* cancellable,
                      GError** error)
{
#line 192 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 192 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return MIDORI_DATABASE_GET_CLASS (self)->init (self, cancellable, error);
#line 2673 "midori-database.c"
}


gboolean
midori_database_exists (MidoriDatabase* self,
                        const gchar* path)
{
	gboolean result = FALSE;
#line 249 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 249 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 250 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = g_file_test (path, G_FILE_TEST_EXISTS);
#line 250 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 2690 "midori-database.c"
}


gboolean
midori_database_attach (MidoriDatabase* self,
                        const gchar* path,
                        const gchar* alias,
                        GError** error)
{
	gboolean result = FALSE;
	gchar* real_path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean _tmp12_;
	GError * _inner_error_ = NULL;
#line 258 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 258 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 258 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (alias != NULL, FALSE);
#line 259 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = midori_database_resolve_path (self, path);
#line 259 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	real_path = _tmp0_;
#line 260 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = real_path;
#line 260 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (!midori_database_exists (self, _tmp1_)) {
#line 2724 "midori-database.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp2_ = g_strdup_printf ("Failed to attach database %s", path);
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp3_ = _tmp2_;
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp4_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_OPEN, _tmp3_);
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = _tmp4_;
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp3_);
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp5_;
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2743 "midori-database.c"
			gboolean _tmp6_ = FALSE;
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp6_;
#line 2751 "midori-database.c"
		} else {
			gboolean _tmp7_ = FALSE;
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 261 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp7_;
#line 2762 "midori-database.c"
		}
	}
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp9_ = real_path;
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp10_ = g_strdup_printf ("ATTACH DATABASE '%s' AS '%s';", _tmp9_, alias);
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp11_ = _tmp10_;
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp12_ = midori_database_exec (self, _tmp11_, &_inner_error_);
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (_tmp11_);
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp8_ = _tmp12_;
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2781 "midori-database.c"
			gboolean _tmp13_ = FALSE;
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp13_;
#line 2789 "midori-database.c"
		} else {
			gboolean _tmp14_ = FALSE;
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (real_path);
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp14_;
#line 2800 "midori-database.c"
		}
	}
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp8_;
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (real_path);
#line 262 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 2809 "midori-database.c"
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return _data3_;
#line 2820 "midori-database.c"
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2831 "midori-database.c"
		MidoriDatabase* self;
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		self = _data3_->self;
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_data3_->schema);
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_object_unref0 (self);
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_slice_free (Block3Data, _data3_);
#line 2841 "midori-database.c"
	}
}


static gboolean
__lambda6_ (Block3Data* _data3_,
            GError** error)
{
	MidoriDatabase* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self = _data3_->self;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = _data3_->schema;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = midori_database_exec (self, _tmp1_, &_inner_error_);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2865 "midori-database.c"
			gboolean _tmp2_ = FALSE;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp2_;
#line 2871 "midori-database.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp3_;
#line 2880 "midori-database.c"
		}
	}
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp0_;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 2887 "midori-database.c"
}


static gboolean
___lambda6__midori_database_callback (gpointer self,
                                      GError** error)
{
	gboolean result;
	result = __lambda6_ (self, error);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 2899 "midori-database.c"
}


gboolean
midori_database_exec_script (MidoriDatabase* self,
                             const gchar* filename,
                             GError** error)
{
	gboolean result = FALSE;
	Block3Data* _data3_;
	gchar* basename = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** parts = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint parts_length1;
	gint _parts_size_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* schema_filename = NULL;
	gchar** _tmp19_;
	gint _tmp19__length1;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GError * _inner_error_ = NULL;
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_data3_->_ref_count_ = 1;
#line 265 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_data3_->self = g_object_ref (self);
#line 266 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->priv->_path;
#line 266 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = g_path_get_basename (_tmp0_);
#line 266 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	basename = _tmp1_;
#line 267 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp2_ = basename;
#line 267 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ".", 0);
#line 267 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	parts = _tmp4_;
#line 267 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	parts_length1 = _vala_array_length (_tmp3_);
#line 267 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_parts_size_ = parts_length1;
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp7_ = parts;
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp7__length1 = parts_length1;
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp7_ != NULL) {
#line 2968 "midori-database.c"
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp8_ = parts;
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp8__length1 = parts_length1;
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp9_ = _tmp8_[0];
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp6_ = _tmp9_ != NULL;
#line 2980 "midori-database.c"
	} else {
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp6_ = FALSE;
#line 2984 "midori-database.c"
	}
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp6_) {
#line 2988 "midori-database.c"
		gchar** _tmp10_;
		gint _tmp10__length1;
		const gchar* _tmp11_;
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp10_ = parts;
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp10__length1 = parts_length1;
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp11_ = _tmp10_[1];
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = _tmp11_ != NULL;
#line 3000 "midori-database.c"
	} else {
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = FALSE;
#line 3004 "midori-database.c"
	}
#line 268 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (!_tmp5_) {
#line 3008 "midori-database.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GError* _tmp15_;
		GError* _tmp16_;
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp12_ = self->priv->_path;
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp13_ = g_strdup_printf ("Failed to deduce schema filename from %s", _tmp12_);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp14_ = _tmp13_;
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp15_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_NAMING, _tmp14_);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp16_ = _tmp15_;
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp14_);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp16_;
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 3030 "midori-database.c"
			gboolean _tmp17_ = FALSE;
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			block3_data_unref (_data3_);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_data3_ = NULL;
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp17_;
#line 3044 "midori-database.c"
		} else {
			gboolean _tmp18_ = FALSE;
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			block3_data_unref (_data3_);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_data3_ = NULL;
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 269 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp18_;
#line 3061 "midori-database.c"
		}
	}
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp19_ = parts;
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp19__length1 = parts_length1;
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp20_ = _tmp19_[0];
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp21_ = g_strconcat (_tmp20_, "/", NULL);
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp22_ = _tmp21_;
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp23_ = g_strconcat (_tmp22_, filename, NULL);
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp24_ = _tmp23_;
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp25_ = g_strconcat (_tmp24_, ".sql", NULL);
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp26_ = _tmp25_;
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp27_ = midori_paths_get_res_filename (_tmp26_);
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp28_ = _tmp27_;
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (_tmp26_);
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (_tmp24_);
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (_tmp22_);
#line 270 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	schema_filename = _tmp28_;
#line 3094 "midori-database.c"
	{
		const gchar* _tmp29_;
		gchar* _tmp30_ = NULL;
#line 273 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp29_ = schema_filename;
#line 273 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_file_get_contents (_tmp29_, &_tmp30_, NULL, &_inner_error_);
#line 273 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_data3_->schema);
#line 273 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_data3_->schema = _tmp30_;
#line 273 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3108 "midori-database.c"
			goto __catch14_g_error;
		}
	}
	goto __finally14;
	__catch14_g_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		GError* _tmp34_;
		GError* _tmp35_;
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_error_ = _inner_error_;
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = NULL;
#line 275 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp31_ = schema_filename;
#line 275 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp32_ = g_strdup_printf ("Failed to open schema: %s", _tmp31_);
#line 275 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp33_ = _tmp32_;
#line 275 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp34_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_FILENAME, _tmp33_);
#line 275 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp35_ = _tmp34_;
#line 275 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (_tmp33_);
#line 275 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp35_;
#line 275 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_error_free0 (_error_);
#line 3141 "midori-database.c"
		goto __finally14;
	}
	__finally14:
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 3149 "midori-database.c"
			gboolean _tmp36_ = FALSE;
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (schema_filename);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			block3_data_unref (_data3_);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_data3_ = NULL;
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp36_;
#line 3165 "midori-database.c"
		} else {
			gboolean _tmp37_ = FALSE;
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (schema_filename);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			block3_data_unref (_data3_);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_data3_ = NULL;
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 272 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp37_;
#line 3184 "midori-database.c"
		}
	}
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_transaction (self, ___lambda6__midori_database_callback, _data3_, &_inner_error_);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 3193 "midori-database.c"
			gboolean _tmp38_ = FALSE;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (schema_filename);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			block3_data_unref (_data3_);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_data3_ = NULL;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp38_;
#line 3209 "midori-database.c"
		} else {
			gboolean _tmp39_ = FALSE;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (schema_filename);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (basename);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			block3_data_unref (_data3_);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_data3_ = NULL;
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 277 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp39_;
#line 3228 "midori-database.c"
		}
	}
#line 278 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = TRUE;
#line 278 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (schema_filename);
#line 278 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 278 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (basename);
#line 278 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	block3_data_unref (_data3_);
#line 278 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_data3_ = NULL;
#line 278 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 3245 "midori-database.c"
}


gboolean
midori_database_transaction (MidoriDatabase* self,
                             MidoriDatabaseCallback callback,
                             gpointer callback_target,
                             GError** error)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 281 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 282 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_exec (self, "BEGIN TRANSACTION;", &_inner_error_);
#line 282 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 282 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 3265 "midori-database.c"
			gboolean _tmp0_ = FALSE;
#line 282 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 282 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp0_;
#line 3271 "midori-database.c"
		} else {
			gboolean _tmp1_ = FALSE;
#line 282 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 282 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 282 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp1_;
#line 3280 "midori-database.c"
		}
	}
#line 283 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	callback (callback_target, &_inner_error_);
#line 283 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 283 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 3289 "midori-database.c"
			gboolean _tmp2_ = FALSE;
#line 283 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 283 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp2_;
#line 3295 "midori-database.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 283 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 283 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 283 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp3_;
#line 3304 "midori-database.c"
		}
	}
#line 284 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_exec (self, "COMMIT;", &_inner_error_);
#line 284 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 284 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 3313 "midori-database.c"
			gboolean _tmp4_ = FALSE;
#line 284 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 284 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp4_;
#line 3319 "midori-database.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 284 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 284 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 284 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp5_;
#line 3328 "midori-database.c"
		}
	}
#line 285 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = TRUE;
#line 285 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 3335 "midori-database.c"
}


gboolean
midori_database_exec (MidoriDatabase* self,
                      const gchar* query,
                      GError** error)
{
	gboolean result = FALSE;
	sqlite3* _tmp0_;
	sqlite3* _tmp1_;
	gint _tmp2_;
	GError * _inner_error_ = NULL;
#line 288 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 288 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (query != NULL, FALSE);
#line 289 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = midori_database_get_db (self);
#line 289 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = _tmp0_;
#line 289 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp2_ = _sqlite3_exec (_tmp1_, query, NULL, NULL, NULL);
#line 289 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp2_ != SQLITE_OK) {
#line 3361 "midori-database.c"
		sqlite3* _tmp3_;
		sqlite3* _tmp4_;
		const gchar* _tmp5_;
		GError* _tmp6_;
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp3_ = midori_database_get_db (self);
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp4_ = _tmp3_;
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp5_ = sqlite3_errmsg (_tmp4_);
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp6_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp5_);
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_inner_error_ = _tmp6_;
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 3378 "midori-database.c"
			gboolean _tmp7_ = FALSE;
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp7_;
#line 3384 "midori-database.c"
		} else {
			gboolean _tmp8_ = FALSE;
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 290 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return _tmp8_;
#line 3393 "midori-database.c"
		}
	}
#line 291 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = TRUE;
#line 291 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 3400 "midori-database.c"
}


MidoriDatabaseStatement*
midori_database_prepare (MidoriDatabase* self,
                         const gchar* query,
                         GError** error,
                         ...)
{
	MidoriDatabaseStatement* result = NULL;
	MidoriDatabaseStatement* statement = NULL;
	MidoriDatabaseStatement* _tmp0_;
	va_list args = {0};
	const gchar* pname = NULL;
	const gchar* _tmp1_;
	gboolean _tmp27_;
	GError * _inner_error_ = NULL;
#line 299 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 299 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 300 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = midori_database_statement_new (self, query, &_inner_error_);
#line 300 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	statement = _tmp0_;
#line 300 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 300 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 300 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 300 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 3434 "midori-database.c"
		} else {
#line 300 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 300 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 300 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			return NULL;
#line 3442 "midori-database.c"
		}
	}
#line 301 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	va_start (args, error);
#line 302 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp1_ = va_arg (args, gchar*);
#line 302 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	pname = _tmp1_;
#line 303 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	while (TRUE) {
#line 3453 "midori-database.c"
		const gchar* _tmp2_;
		GType ptype = 0UL;
		GType _tmp3_;
		const gchar* _tmp26_;
#line 303 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp2_ = pname;
#line 303 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (!(_tmp2_ != NULL)) {
#line 303 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			break;
#line 3464 "midori-database.c"
		}
#line 304 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		ptype = va_arg (args, GType);
#line 305 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp3_ = ptype;
#line 305 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		if (_tmp3_ == G_TYPE_STRING) {
#line 3472 "midori-database.c"
			gchar* pvalue = NULL;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			MidoriDatabaseStatement* _tmp6_;
			const gchar* _tmp7_;
			GType _tmp8_;
			const gchar* _tmp9_;
#line 306 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp4_ = va_arg (args, gchar*);
#line 306 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp5_ = g_strdup (_tmp4_);
#line 306 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			pvalue = _tmp5_;
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp6_ = statement;
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp7_ = pname;
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp8_ = ptype;
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp9_ = pvalue;
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			midori_database_statement_bind (_tmp6_, _tmp7_, &_inner_error_, _tmp8_, _tmp9_, NULL);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					g_propagate_error (error, _inner_error_);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_g_free0 (pvalue);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					va_end (args);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_g_object_unref0 (statement);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					return NULL;
#line 3510 "midori-database.c"
				} else {
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_g_free0 (pvalue);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					va_end (args);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_g_object_unref0 (statement);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					g_clear_error (&_inner_error_);
#line 307 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					return NULL;
#line 3524 "midori-database.c"
				}
			}
#line 305 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_g_free0 (pvalue);
#line 3529 "midori-database.c"
		} else {
			GType _tmp10_;
#line 308 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			_tmp10_ = ptype;
#line 308 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
			if (_tmp10_ == G_TYPE_INT64) {
#line 3536 "midori-database.c"
				gint64 pvalue = 0LL;
				MidoriDatabaseStatement* _tmp11_;
				const gchar* _tmp12_;
				GType _tmp13_;
				gint64 _tmp14_;
#line 309 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				pvalue = va_arg (args, gint64);
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp11_ = statement;
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp12_ = pname;
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp13_ = ptype;
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp14_ = pvalue;
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				midori_database_statement_bind (_tmp11_, _tmp12_, &_inner_error_, _tmp13_, _tmp14_, NULL);
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						g_propagate_error (error, _inner_error_);
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						va_end (args);
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						_g_object_unref0 (statement);
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						return NULL;
#line 3566 "midori-database.c"
					} else {
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						va_end (args);
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						_g_object_unref0 (statement);
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						g_clear_error (&_inner_error_);
#line 310 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						return NULL;
#line 3578 "midori-database.c"
					}
				}
			} else {
				GType _tmp15_;
#line 311 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				_tmp15_ = ptype;
#line 311 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
				if (_tmp15_ == G_TYPE_DOUBLE) {
#line 3587 "midori-database.c"
					gdouble pvalue = 0.0;
					MidoriDatabaseStatement* _tmp16_;
					const gchar* _tmp17_;
					GType _tmp18_;
					gdouble _tmp19_;
#line 312 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					pvalue = va_arg (args, gdouble);
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp16_ = statement;
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp17_ = pname;
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp18_ = ptype;
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp19_ = pvalue;
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					midori_database_statement_bind (_tmp16_, _tmp17_, &_inner_error_, _tmp18_, _tmp19_, NULL);
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
							g_propagate_error (error, _inner_error_);
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
							va_end (args);
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
							_g_object_unref0 (statement);
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
							return NULL;
#line 3617 "midori-database.c"
						} else {
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
							va_end (args);
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
							_g_object_unref0 (statement);
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
							g_clear_error (&_inner_error_);
#line 313 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
							return NULL;
#line 3629 "midori-database.c"
						}
					}
				} else {
					GType _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					GError* _tmp24_;
					GError* _tmp25_;
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp20_ = ptype;
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp21_ = g_type_name (_tmp20_);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp22_ = g_strdup_printf ("Invalid type '%s' in statement: %s", _tmp21_, query);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp23_ = _tmp22_;
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp24_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp23_);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_tmp25_ = _tmp24_;
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_g_free0 (_tmp23_);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					_inner_error_ = _tmp25_;
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						g_propagate_error (error, _inner_error_);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						va_end (args);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						_g_object_unref0 (statement);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						return NULL;
#line 3665 "midori-database.c"
					} else {
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						va_end (args);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						_g_object_unref0 (statement);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						g_clear_error (&_inner_error_);
#line 315 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
						return NULL;
#line 3677 "midori-database.c"
					}
				}
			}
		}
#line 316 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp26_ = va_arg (args, gchar*);
#line 316 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		pname = _tmp26_;
#line 3686 "midori-database.c"
	}
#line 318 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp27_ = self->trace;
#line 318 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (_tmp27_) {
#line 3692 "midori-database.c"
		FILE* _tmp28_;
#line 319 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp28_ = stdout;
#line 319 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		fprintf (_tmp28_, "\n");
#line 3698 "midori-database.c"
	}
#line 320 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = statement;
#line 320 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	va_end (args);
#line 320 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 3706 "midori-database.c"
}


sqlite3*
midori_database_get_db (MidoriDatabase* self)
{
	sqlite3* result;
	sqlite3* _tmp0_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 165 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->_db;
#line 165 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp0_;
#line 165 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 3723 "midori-database.c"
}


const gchar*
midori_database_get_path (MidoriDatabase* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->priv->_path;
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp0_;
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 3740 "midori-database.c"
}


void
midori_database_set_path (MidoriDatabase* self,
                          const gchar* value)
{
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (g_strcmp0 (value, midori_database_get_path (self)) != 0) {
#line 3752 "midori-database.c"
		gchar* _tmp0_;
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_tmp0_ = g_strdup (value);
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		_g_free0 (self->priv->_path);
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		self->priv->_path = _tmp0_;
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_object_notify_by_pspec ((GObject *) self, midori_database_properties[MIDORI_DATABASE_PATH_PROPERTY]);
#line 3762 "midori-database.c"
	}
}


gboolean
midori_database_get_first_use (MidoriDatabase* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 173 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 173 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = self->priv->_first_use;
#line 173 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	result = _tmp0_;
#line 173 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	return result;
#line 3780 "midori-database.c"
}


void
midori_database_set_first_use (MidoriDatabase* self,
                               gboolean value)
{
#line 173 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 173 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	if (midori_database_get_first_use (self) != value) {
#line 173 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		self->priv->_first_use = value;
#line 173 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_object_notify_by_pspec ((GObject *) self, midori_database_properties[MIDORI_DATABASE_FIRST_USE_PROPERTY]);
#line 3796 "midori-database.c"
	}
}


static void
midori_database_class_init (MidoriDatabaseClass * klass)
{
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_parent_class = g_type_class_peek_parent (klass);
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_type_class_add_private (klass, sizeof (MidoriDatabasePrivate));
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	((MidoriDatabaseClass *) klass)->init = (gboolean (*) (MidoriDatabase *, GCancellable*, GError**)) midori_database_real_init;
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_midori_database_get_property;
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_midori_database_set_property;
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->finalize = midori_database_finalize;
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_DB_PROPERTY, midori_database_properties[MIDORI_DATABASE_DB_PROPERTY] = g_param_spec_pointer ("db", "db", "db", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_PATH_PROPERTY, midori_database_properties[MIDORI_DATABASE_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_FIRST_USE_PROPERTY, midori_database_properties[MIDORI_DATABASE_FIRST_USE_PROPERTY] = g_param_spec_boolean ("first-use", "first-use", "first-use", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3822 "midori-database.c"
}


static void
midori_database_g_initable_interface_init (GInitableIface * iface)
{
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	midori_database_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	iface->init = (gboolean (*) (GInitable *, GCancellable*, GError**)) midori_database_init;
#line 3833 "midori-database.c"
}


static void
midori_database_instance_init (MidoriDatabase * self)
{
	gchar* _tmp0_;
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->priv = MIDORI_DATABASE_GET_PRIVATE (self);
#line 164 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->trace = FALSE;
#line 166 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->_db = NULL;
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_tmp0_ = g_strdup (":memory:");
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->priv->_path = _tmp0_;
#line 173 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self->priv->_first_use = FALSE;
#line 3853 "midori-database.c"
}


static void
midori_database_finalize (GObject * obj)
{
	MidoriDatabase * self;
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MIDORI_TYPE_DATABASE, MidoriDatabase);
#line 166 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_sqlite3_close0 (self->_db);
#line 167 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	_g_free0 (self->priv->_path);
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	G_OBJECT_CLASS (midori_database_parent_class)->finalize (obj);
#line 3869 "midori-database.c"
}


GType
midori_database_get_type (void)
{
	static volatile gsize midori_database_type_id__volatile = 0;
	if (g_once_init_enter (&midori_database_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MidoriDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) midori_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MidoriDatabase), 0, (GInstanceInitFunc) midori_database_instance_init, NULL };
		static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) midori_database_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType midori_database_type_id;
		midori_database_type_id = g_type_register_static (G_TYPE_OBJECT, "MidoriDatabase", &g_define_type_info, 0);
		g_type_add_interface_static (midori_database_type_id, g_initable_get_type (), &g_initable_info);
		g_once_init_leave (&midori_database_type_id__volatile, midori_database_type_id);
	}
	return midori_database_type_id__volatile;
}


static void
_vala_midori_database_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	MidoriDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_DATABASE, MidoriDatabase);
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	switch (property_id) {
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_DB_PROPERTY:
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_value_set_pointer (value, midori_database_get_db (self));
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_PATH_PROPERTY:
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_value_set_string (value, midori_database_get_path (self));
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_FIRST_USE_PROPERTY:
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		g_value_set_boolean (value, midori_database_get_first_use (self));
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 3917 "midori-database.c"
		default:
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 3923 "midori-database.c"
	}
}


static void
_vala_midori_database_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	MidoriDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_DATABASE, MidoriDatabase);
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
	switch (property_id) {
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_PATH_PROPERTY:
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		midori_database_set_path (self, g_value_get_string (value));
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		case MIDORI_DATABASE_FIRST_USE_PROPERTY:
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		midori_database_set_first_use (self, g_value_get_boolean (value));
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 3950 "midori-database.c"
		default:
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 163 "/builddir/build/BUILD/midori-0.5.12/midori/midori-database.vala"
		break;
#line 3956 "midori-database.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



